allzero <- function(stanow,rtnow,n,nobs,cnt,iflag,linear, ndist,strnow,alt) {
#
#  this subroutine checks to see if all counts were zero on a route.
#  if so, it kicks the data out to an all-zero file. it also kicks out all singular matrices or n<2  called from the main program

    #parameter (myrs=200)
    #double precision cnt(myrs),dummy
    #real stanow
    #integer alt,iflag

    iflag=1  #    separate out routes with too much data to be analyzed
    #if(n  >  myrs  &&  nobs  >  45) return
    dummy=log(0.5); if(linear  ==  1) dummy = 0

    xsum=sum(cnt[1:n]>(dummy+0.02))  #   set the route to all zero if <1 year has counts >0
    iflag=1-(xsum>0)

    if(iflag  !=  0) {
       aa=aa2=na1=0  #   now print out those zero routes to the slope file so they can be added in to the counts.
       if(alt == 3) a8<<-c(a8,sprintf("%7d%6d%5d%14.8f%14.8f%14.6f%29.2f%3d",stanow,rtnow,strnow, aa,aa,aa,aa2,na1))
       return(list(iflag=iflag, nobs=nobs))
    }
#        these next limits change with the number of years!!!   now n must be > nobs+1
#        if disturbance is to be included, set nobs to nobs+1.  does this cause errors?

    if(ndist  ==  0) nobs=nobs+1
    if(n  >  (nobs+1)) return(list(iflag=iflag, nobs=nobs))
    
    iflag=1
#  if the route was run at least 2 years by the same observer,  set flag=2.
    if(n >= 2 && n > nobs && ndist != 0) {
       iflag=2; if(n > 2) iflag=3
       return(list(iflag=iflag, nobs=nobs))
    }
    aa=0; na1=1; aa2=exp(cnt[1])-0.5
    if(alt == 3) a8<<-c(a8,sprintf("%7d%6d%5d%14.8f%14.8f%14.6f%29.2f%3d",stanow,rtnow,strnow, aa,aa,aa,aa2,na1))
    return(list(iflag=iflag, nobs=nobs))
}