analy <- function(nobs,n,xncol,des,obs,cnt) {
#         this subroutine (analy) comes up with estimates of the residuals, which then must be back-transformed

    xcall=setcolmn(nobs,n,xncol,des,obs)
    des=xcall$des; obs=xcall$obs
    xpr=t(des)
    xpx=xpr %*% des    #  find the x prime-x matrix
    xpxinv=solve(xpx)     #  find the x prime x inverse matrix
    wtxpx=xpxinv[2,2]                                      #  set up the weighting factor for the variances
    xpy=xpr %*% cnt         #  find the x prime y vector
    bmat=xpxinv %*% xpy     #  find the b vector (x'x)-1 (x'y)
   
    cova=varcov(n,xncol,cnt,xpy,bmat,xpxinv)           #  xcall=the subroutine to get the var-cov matrix
    xcall=mmeans(n,xncol,des,bmat,cova)
    margm=xcall$margm; varmar=xcall$varmar
    return(list(cova=cova, margm=xcall$margm, varmar=xcall$varmar, wtxpx=wtxpx, bmat=bmat, des=des, obs=obs))
}
