      SUBROUTINE BOOTDO(CIL,CIU,CILP,CIUP,N,M,SR,AVEP,AMED,UNIT,ITOT,STORSTR,ISUM,VARBOOT,IX,RNUM)
      DIMENSION CIL(3),CIU(3),CILP(3),CIUP(3)
      INTEGER N(280,4), M, UNIT,STORSTR,IX,RNUM
      REAL SR(280,4),RANDN
      DOUBLE PRECISION BOOTEST(8000),ASUMBM, ASUMM,sumboot,sumsqb,sumden,sumnum,summ,sumbm,bootmin,bootmax,avgboot,varbt

      COMMON /O/ OB(280,6,150)

C  ALL SLOPES HAVE BEEN READ IN, SO NOW CALCULATE THE BOOTSTRAP ESTIMATE
C     COUNTERS:
C          SUMBOOT= SUM OF BOOTSTRAP ESTIMATES
C          SUMSQB = SUM OF SQUARED BOOTSTRAP ESTIMATES
C          BOOTMIN= SMALLEST ESTIMATE
C          BOOTMAX= LARGEST ESTIMATE

      SUMBOOT=0.0d0
      SUMSQB= 0.0d0
      BOOTMIN=10000000.0
      BOOTMAX=0.0

C  GET RID OF STATES WITH 0 ROUTES

      ISUM=0
      DO I=1,M
        IF(N(I,1).GT.1) ISUM=1
      END DO
      IF(ISUM .EQ. 0) RETURN

C   SET INDEX FOR NUMBER OF REPLICATES DESIRED (IT IS NOW 400)

C  SET WITHIN-REP COUNTERS TO 0
C     COUNTERS:
C           SUMNUM = SUM OF NUMERATORS FOR ESTIMATE
C           SUMDEN = SUM OF DENOMINATORS FOR ESTIMATE

      IREPS=8000
      DO 400 L=1,IREPS
        BOOTEST(L)=0.
        SUMNUM=0.0d0
        SUMDEN=0.0d0
        DO 350 I=1,M
          IF(N(I,1) .EQ. 0) GO TO 350

C  WITHIN EACH AREA, N(I,1) ROUTES HAVE TO BE SELECTED WITH REPLACEMENT. SET UP THE COUNTERS TO DO THAT.
C     COUNTERS:
C           SUMBM = SUM OF SLOPE*MMEAMN/(VARIANCE*N)
C           SUMM= SUM OF MMEAN/(VARIANCE*N)
C     NOW MODIFIED TO HAVE SUM(B**(1/2))*MM IN SUMBM AND B**(-1/2)*MM IN DENOM

          SUMM=0.0d0
          SUMBM=0.0d0
          DO J=1, N(I,1)
            RANDN= RANDU(IX) ! PICK A RANDOM NUMBER. THIS RANDOM NUMBER GENERATOR WAS FROM THE MALLARD MODEL
            AN=real(N(I,1))
            RANDN=RANDN*AN+1.0 !  MULTIPLY THE NUMBER BY THE NUMBER OF OBSERVATIONS, THEN ADD 1 (TO PUT IT IN THE RANGE).
            NRAN=ifix(RANDN)   !  THEN TRUNCATE IT TO AN INTEGER.
            IF(NRAN .GT. N(I,1)) NRAN=N(I,1) !  NOW, A CHANCE EXISTS THAT THE RANDOM NUMBER WILL ROUND OFF TO  BE OUTSIDE OF THE RANGE 1,..., N(I,1).
            IF(NRAN .LT. 1) NRAN=1           !    THESE NEXT STATEMENTS GUARD AGAINST THIS.

C  NOW SUM OBSERVATION OB(I,1,NRAN). USE THE NUMBER OF SLOPES IN THE STATE-STRATA COMBO FOR  THE AN IN THIS CASE.

            AN=SR(I,4)
            IF(AN.GT.0.0 .AND. OB(I,2,NRAN).GT..000001) THEN

C  THE FIRST LINES (COMMENTED) HAVE SAMPLE SIZE WEIGHTING

C              SUMBM=SUMBM+(OB(I,1,NRAN)**(0.5)*OB(I,3,NRAN))/(OB(I,2,NRAN))*AN
C              SUMM=SUMM+(OB(I,1,NRAN)**(-0.5)*OB(I,3,NRAN)/(OB(I,2,NRAN))*AN)

C   THIS EQUATION DOES NOT HAVE SAMPLE SIZE WEIGHTING

               SUMBM=SUMBM+SQRT(OB(I,1,NRAN))*OB(I,3,NRAN)/OB(I,2,NRAN)
               SUMM=SUMM+OB(I,3,NRAN)/OB(I,2,NRAN)/SQRT(OB(I,1,NRAN))
CX             SUMBM=SUMBM+(OB(I,1,NRAN)**(0.5)*OB(I,3,NRAN))/OB(I,2,NRAN)
CX             SUMM=SUMM+(OB(I,1,NRAN)**(-0.5)*OB(I,3,NRAN)/OB(I,2,NRAN))
            END IF
          END DO

          ASUMBM=SR(I,2)*SUMBM  !   NOW SUM OVER THE AREAS FOR THIS REPLICATE
          ASUMM=SR(I,2)*SUMM
          SUMNUM=SUMNUM+(ASUMBM)
          SUMDEN=SUMDEN+(ASUMM)

C  PRINT OUT NUMERATORS AND DENOMINATORS FOR BIG BOOTSTRAPS ONLY FOR THE STATE ESTIMATES

          IF(STORSTR .EQ. 1) RNUM=RNUM+1
  350     CONTINUE

C  THAT REPLICATE IS COMPLETE, SO NOW FIND THE ESTIMATE AND STORE THE SUMS, SUMSQ, MAX, MIN.
C  NOTE THAT I HAVE PUT THIS 0.0001 IN TO GUARD AGAINST UNDERFLOW

        BOOTEST(L)=SUMNUM/SUMDEN

        SUMBOOT=SUMBOOT+BOOTEST(L)
        SUMSQB=SUMSQB+(BOOTEST(L)*BOOTEST(L))
        IF(BOOTEST(L) .LT. BOOTMIN) BOOTMIN=BOOTEST(L)
        IF(BOOTEST(L) .GT. BOOTMAX) BOOTMAX=BOOTEST(L)
        UNIT=0
  400   CONTINUE

C   THE BOOTSTRAP IS NOW DONE. FIND VARIANCES, ETC USING 'IREPS'  AS THE NUMBER OF REPLICATIONS.
C  FIRST, LETS FIND THE MEDIAN BY SORTING THE BOOTEST(L)'S AND  FINDING THE 200TH OBSERVATION.
       CALL QRSORT(BOOTEST,8000)

C  BOOTEST(200) IS THE MEDIAN VALUE!  CHANGE THE INDEX VALUE IF THE NUMBER OF REPS CHANGE!!!!!

      REPS=FLOAT(IREPS)
      AVGBOOT=SUMBOOT/REPS
      AVEBOOT=real(avgboot)
      varbt=0.
      do i=1,ireps
         varbt=varbt+(bootest(i)-avgboot)*(bootest(i)-avgboot)
      end do
      varboot=real(varbt)/(reps-1.)

c      VARBOOT=(SUMSQB-(REPS*AVEBOOT*AVEBOOT))/(REPS-1)
      ITOT=0 !   FIND THE TOTAL NUMBER OF ROUTES IN THE STATE FOR PRINTING OUT
      DO I=1,M
        ITOT=N(I,1)+ITOT
      END DO

      IF(VARBOOT .LT. 0.0) VARBOOT=0.0  !  IF VARBOOT IS NEGATIVE, SET IT EQUAL TO ZERO.
      DO I=1,3
        IF(I .EQ. 1) ZVAL=1.645
        IF(I .EQ. 2) ZVAL=1.96
        IF(I .EQ. 3) ZVAL=2.575
        CI=ZVAL*(SQRT(VARBOOT))
        CIL(I)=AVEBOOT-CI
        CIU(I)=AVEBOOT+CI
        CILP(I)=(CIL(I)-1.0)*100.0
        CIUP(I)=(CIU(I)-1.0)*100.0
      END DO

      AVEP=(AVEBOOT-1.0)*100.0  !   CONVERT THESE TO % USING %=(C-1.0)*100.0
      AMED=(REAL(BOOTEST(4000))-1.0)*100.0
      VARBOOT=(VARBOOT)*(10000.0)
      RETURN
      END
