calclink <- function(stanow,rtnow,n,xncol,des,cnt,yrf,blue){ 
#  this subroutine reformats the design matrix and counts to

    #common /newt/y(myrs),x(myrs),d(myrs,mcols),ian,iaxncol
    #  put the counts (-1=missing) into iobs, put the observer number
   
   myrs=des[nrow(des),2]-yrf+1
   ian=n; iaxncol=xncol-1; amin=yrf; yr=rep(0,myrs); d=matrix(0,myrs,xncol-1)
    amin=min(des[,2])

    #  now go through the data for the route and put it in matrices
    if(xncol == 2) { d[,1]=1; yr=rep(1,n) }#   first, set the case where 1 observer occurs to 1
       
    #  now go through by years and set up the d matrix
    
     y=y1=des[,2]-amin+1 #  find the year for this one (note years start at yrf which should be changed sometime
     x=x1=exp(cnt)-0.5

    #  assign a number to each observer- note the final observer is a blank  it is now set up to have 12 observers.  note that yr is a column of observers
    for (i in 1:n) {
        if(xncol != 2) {
          for (j in 3:xncol) if(des[i,j] >= 1) { d[i,j-2]=1; yr[i]=(j-2) }
          if(yr[i] < 1) { d[i,xncol-1]=1; yr[i]=(xncol-1) }
       }
    }
    #  now, data are in the yr, x, y, and d matrices. first, find if sufficient data exist for the link procedure for this to be true,
    #  we need at least 2 nonzero counts for at least 1 observer so, go through the observers, and calculate the number of
    #  nonzero counts, and set a flag to 1 if an observer has >1 nonzero counts
    iflag=0; io=io2=rep(0,xncol-1)

    for (i in 1:n) {
       if(x[i] >  0.01) io[floor(yr[i])]=io[floor(yr[i])]+1
       io2[floor(yr[i])]=io2[floor(yr[i])]+1
       if((io[floor(yr[i])] > 1) &&  (io2[floor(yr[i])] > 1)) iflag=1
    }
    blink=-1; aa=0; itmp=floor(stanow*1000+rtnow)
    if(iflag == 0) return(list(b=b, blink=blink, var=var, iflag=iflag))

    # routes that reach here are ok.  so i think we are ready to call newton
    b=blue/14; iwork=var=0
   
    xcall=optnewt(b, d[1:n,], x[1:n], y[1:n], iwork, n); b=xcall$b; iwork=xcall$iwork
    
    if(iwork == 2) iflag=0
    if(iflag == 0) return(list(b=b, blink=blink, var=var, iflag=iflag))
    blink=b

    df=sumg2=0               #   now calculate the variance.  fit[i]=fitted count for year i. 
    for (j in 1:(xncol-1)) { #   for (this for each observer (there are xncol-1 observers in all)
       total=sumb=inum=0
       for (i in 1:n) {
          if(d[i,j] >= 1) {
             total=total+x1[i]
             sumb=sumb+(blink^(y1[i]+(amin-yrf))) #  note that i changed this to have itbe scaled so the first one is 1
             inum=inum+1
             if(sumb == 0) cat('zero sumb', total,sumb,'\n')
          }
       }
       if(total > 0 && inum > 1) {  #  those are the sums, so calculate the g^2 within years.
          g2=0                              #   if total =0. or num=1, skip this turkey
          for (i in 1:n) {
             if(d[i,j] >= 1 && sumb > 0 && total != 0 && blink != 0  &&  y1[i] >= 0  &&  (x1[i]/(total*(blink^y1[i])/sumb)) >= 0) {
                if(x1[i] > 0) g2=g2+2*x1[i]*log(x1[i]/(total*(blink^y1[i])/sumb))      
                df=df+1
             }
          }
          df=df-1 #   subtract off the observer, add on the g2 to sumg2
          sumg2=sumg2+g2
       }
    }
    if(df > 1) var=var*sumg2/(df-1)  #   make the total variance
    return(list(b=b, blink=blink, var=sqrt(var), iflag=iflag))
}

optnewt <- function(b, d, x, y, iwork2, n) {
    #           subroutine optnewt - optimizes function using  "newton-raphson" algorithm
    #
    #           input: n - number of years         }    passed via
    #                  k - number of observers     }    common block
    #                  d(n,k) - design matrix      }    "newt"
    #                  x(n) - counts               }
    #                  y(n) - observers            }
    #
    #            output b - 1 element array of optimized value
    #
    #common /newt/y(myrs),x(myrs),d(myrs,mcols),n,k
    #common /nwt1/s,t(myrs),iwork
    #external willie

    iwork <<-iwork2; tol=.0000001; ishow=0; istep=1000; k=ncol(d)
    s=sum(y*x); t=rep(0,k);
    for (j in 1:k) t[j]=sum(d[,j]*x)
    iseed=43211; set.seed(iseed); ir=1; ireps=50; amax=-99999999.0; 
    ireps=1
 
    for (ir in 1:ireps) {
       b=.01 #+ 3.*runif(1)  #  range of b1: 0.01 to 2
       alik=willie(b, s, d, t, y)  #  evaluate function
       if(alik >= amax) { b1=b;  amax=alik }
    }
    b=b1
    xcall=newton(b,1,tol,ishow,istep, s, d, t, y); b=xcall$b; var=xcall$var; 
    if((b > 999.) || (b < 0.01)) b=0.01
    iwork2=iwork
    return(list(b=b, var=var, iwork=iwork))
}

willie <- function(b, s, d, t, y) {
    #common /newt/y(myrs),x(myrs),d(myrs,mcols),n,k
    #common /nwt1/s,t(myrs),iwork
    if(b <= 0) iwork <<-1   else {
       n=nrow(d); k=ncol(d); w=s*log(b); bb=b^y
       for (i in 1:k) w=w-t[i]*log(sum(d[,i]*bb))
    }
    return(w)
}

gradp <- function(x, s, d, t, y){
    #  args: func = function to be evaluated  x = n*1 vector specifying x0
    dh=0.00000001; dlx0=willie(x, s, d, t, y); grad=x; n=length(x)
    return((willie(x+dh, s, d, t, y)-dlx0)/dh)
}

hessp <- function(x, s, d, t, y){

    #  args: func = function to be evaluated       x = n*1 vector specifying x0

    #common /nwt1/s,t(myrs),iwork
    n=length(x); amx=.01  #  compute step size dh (based on gauss proc hessp)
    for (i in 1:n) {
      ax0=abs(x); dax0=1
      if (ax0  > 0 ) dax0=x[i]/ax0
      if(ax0  >  amx)amx=ax0
    }
    f0=willie(x, s, d, t, y)
    dh=.00001*amx*dax0
    grdd=willie(x+dh, s, d, t, y)
    hess=(willie(x+dh+dh, s, d, t, y)-grdd-grdd+f0)/dh/dh
    return(hess)
}
newton <- function(x,n, tol,ishow,istep, s, d, t, y) {

    # maximises the likelihood function 'func' with respect to a vector of parameters b of length n.
    #     tol determines the convergence criterion, ishow determines whether the iterations
    #      are printed and istep is the maximum number of steps to try to reach convergence

    #common /nwt1/s,t(myrs),iwork
    step=1
    while (step > .005) {
        for (i in 1:istep) {
           lasx=x
           grad=gradp(x, s, d, t, y)
           hess=hessp(x, s, d, t, y)
           vcov=solve(hess)  #  call matinv(hess,vcov,n,myrs)
           prd=-vcov*grad*step
           x=x+prd
           if (i  >  istep) { cat('convergence failure\n'); return }
           dist=sqrt((lasx-x)*(lasx-x))
           if(dist <= tol) break
           if(ishow == 1) cat(i,dist,x,willie(x, s, d, t, y),'\n')
        }
        if(iwork == 1 || dist<=tol) break
        hess=hessp(x, s, d, t, y)
        vcov=solve(hess)   #   call matinv(hess,vcov,n,myrs)
        if(iwork != 1) { vcov=-vcov; var=vcov[1,1] }
    }
    return(list(b=x, hess=hess, vcov=vcov, var=var, iwork=iwork))
}

