      SUBROUTINE calclink(STANOW,RTNOW,N,NCOL,DES,CNT,YRF,Blink,iflag,blue,var) !  THIS SUBROUTINE reformats THE DESIGN MATRIX AND COUNTS TO

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS), CNT(MYRS),Blink
      INTEGER D,iflag,ian,iancol,iwork
      REAL RTNOW,STANOW, yrf
      INTEGER N,NCOL,io(mcols),inum,io2(mcols)
      DOUBLE PRECISION YR(MYRS),Y,x,b(1),blue,amin,var,sumg2,total,sumb,g2,df,x1(myrs),y1(myrs)
      COMMON /newt/Y(MYRS),X(MYRS),D(MYRS,MCOLS),IAN,IANCOL
C  PUT THE COUNTS (-1=MISSING) INTO IOBS, PUT THE OBSERVER NUMBER
      Ian=n
      Iancol=ncol-1
      amin=yrf
      do i=1,MYRS  !   FIRST SET ALL COUNTS TO 0
         yr(i)=0.0d0
         do  j=1,mcols
            d(i,j)=0
         end do
         if(i.le.n) then
            if(des(i,2).lt.amin) amin=des(i,2)
         end if
      END DO

C  NOW GO THROUGH THE DATA FOR THE ROUTE AND PUT IT IN MATRICES


      if(ncol.eq.2) then !   first, set the case where 1 observer occurs to 1
         do j=1,n
            d(j,1)=1
            yr(j)=1.0d0
         END DO
      end if
c  now go through by years and set up the d matrix

      do i=1,n
         Y(I)=des(i,2)-amin+1.0d0 !  FIND THE YEAR FOR THIS ONE (NOTE YEARS START AT YRF WHICH SHOULD BE CHANGED SOMETIME
         X(i)=exp(cnt(i))-0.5
         Y1(I)=des(i,2)-amin+1.0d0
         X1(i)=exp(cnt(i))-0.5

C  ASSIGN A NUMBER TO EACH OBSERVER- NOTE THE FINAL OBSERVER IS A BLANK  IT IS NOW SET UP TO HAVE 12 OBSERVERS.  NOTE THAT YR IS A COLUMN OF OBSERVERS

         IF(NCOL.ne.2) THEN
            do j=3,ncol
               if(des(i,j).ge. 1.0d0) d(i,j-2)=1
               if(des(i,j).ge. 1.0d0) yR(i)=float(j-2)
            END DO
            if(yR(I).lt.1.0d0) d(i,ncol-1)=1
            if(yR(I).lt.1.0d0) yR(i)=float(ncol-1)
         END IF
      END DO
C  NOW, DATA ARE IN THE yr, x, y, and d MATRIces. FIRST, FIND IF SUFFICIENT DATA EXIST FOR THE LINK PROCEDURE FOR THIS TO BE TRUE,
C  WE NEED at least 2 nonzero counts for at least 1 observer so, go through the observers, and calculate the number of
c  nonzero counts, and set a flag to 1 if an observer has >1 nonzero counts
      iflag=0
      do i=1,ncol-1
         io(i)=0
         io2(i)=0
      END DO
      do i=1,n
         if(x(i).gt. 0.01d0) io(idint(yr(i)))=io(idint(yr(i)))+1
         io2(idint(yr(i)))=io2(idint(yr(i)))+1
         if((io(idint(yr(i))).gt.1).and. (io2(idint(yr(i))).gt.1)) iflag=1
      END DO
      blink=-1.0d0
      AA=0.
      itmp=ifix(stanow*1000.+rtnow)
      if(iflag.eq.0) return

C ROUTES THAT REACH HERE ARE OK.  SO I THINK WE ARE READY TO CALL NEWTON
      b(1)=blue/14.0d0
      iwork=0
      var=0.0d0
      CALL OPTNEWT(B(1),iwork,var)
      if(iwork.eq.2) iflag=0
      if(iflag.eq.0) return
       blink=b(1)


      sumg2=0.0d0 !   now calculate the variance.  fit(i)=fitted count for year i.
      df=0.0d0    !   do this for each observer (there are ncol-1 observers in all)
      do j=1,ncol-1
         total=0.0d0
         sumb=0.0d0
         inum=0
         do i=1,n
            if(d(i,j).GE.1) then
               total=total+x1(i)
               sumb=sumb+(blink**(y1(i)+(amin-yrf))) !  note that I changed this to have itbe scaled so the first one is 1
               inum=inum+1
               if(sumb.eq.0.0d0) write(*,*) 'zero sumb', total,sumb
            end if
         END DO

         if(total.gt.0.0d0 .and. inum.gt.1) then  !  those are the sums, so calculate the G**2 within years.
            g2=0.0d0                              !   if total =0. or num=1, skip this turkey
            do i=1,n
               if(d(i,j).ge.1 .and. sumb.gt.0.0d0 .and. total.ne.0.0d0 .and. blink.ne.0.0d0 .and. y1(i).ge.0.0d0 .and. (x1(i)/(total*(blink**y1(i))/sumb)).ge.0.0d0) then
                  if(x1(i).gt.0.0d0) g2=g2+2.0d0*x1(i)*log(x1(i)/(total*(blink**y1(i))/sumb))      
                  df=df+1.0d0
               end if
            END DO
            df=df-1 !   subtract off the observer, add on the g2 to sumg2
            sumg2=sumg2+g2
         end if
      END DO

      if(df.gt.1.0d0) var=var*sumg2/(df-1.0d0)  !   make the total variance
      var=var**(0.5)
      RETURN
      END

      SUBROUTINE OPTNEWT(B,iwork2,var)
c           subroutine optnewt - optimizes function using  "Newton-Raphson" algorithm
c
c           input: N - number of years         }    passed via
c                  K - number of observers     }    common block
c                  D(N,K) - design matrix      }    "newt"
c                  X(N) - counts               }
c                  Y(N) - observers            }
c
c            output B(1) - 1 element array of optimized value
c
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION B(1),var
      INTEGER D
      COMMON /newt/Y(MYRS),X(MYRS),D(MYRS,MCOLS),N,K
      COMMON /nwt1/S,T(MYRS),iwork
      EXTERNAL WILLIE

      iwork=iwork2
      TOL=.0000001
      ISHOW=0
      ISTEP=1000
      S=0.
      DO I=1,N
         S=S+Y(I)*X(I)
      END DO
      DO J=1,K
         T(J)=0.
         DO I=1,N
            T(J)=T(J)+D(I,J)*X(I)
         END DO
      END DO

   40 continue
      ISEED=43211
      call srand(iseed)
      ir=1
      ireps=50
      amax=-99999999.0
      do while (ir.le.ireps)
         ir=ir+1
         b(1)=.01 + 3.*rand(0)  !  range of b1: 0.01 to 2
         alik=WILLIE(b)  !  evaluate function
         if(alik.ge.amax) then
            b1=b(1)
            amax=alik
         end if
      end do
      b(1)=b1
      print *,'b1=',b1  !b=2.3297481536865234

      CALL NEWTON(WILLIE,B,1,TOL,ISHOW,ISTEP,var)
      if((b(1).gt.999.).or.(b(1).lt.0.01)) b(1)=0.01
      if((b(1).gt.999.).or.(b(1).lt.0.01)) go to 40
      IWORK2=IWORK
      RETURN
      END

      FUNCTION WILLIE(B)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      PARAMETER (MYRS=200,MCOLS=40)
      INTEGER D
      DOUBLE PRECISION B(1),BB(MYRS)
      COMMON /newt/Y(MYRS),X(MYRS),D(MYRS,MCOLS),N,K
      COMMON /nwt1/S,T(MYRS),iwork
      if(b(1).le.0.0d0) then
         iwork=1
      else
         WILLIE=S*DLOG(B(1))
         DO I=1,N
            BB(I)=B(1)**Y(I)
         END DO
         DO I=1,K
            SUM=0
            DO J=1,N
               SUM=SUM+D(J,I)*BB(J)
            END DO
            WILLIE=WILLIE-T(I)*DLOG(SUM)
         END DO
      end if
      print *,b, willie
      RETURN
      END

      SUBROUTINE GRADP(FUNC,X,N,GRAD)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

C  ARGS: FUNC = FUNCTION TO BE EVALUATED           X = N*1 VECTOR SPECIFYING X0

      PARAMETER (DH=0.00000001,MYRS=200)
      EXTERNAL FUNC
      DOUBLE PRECISION FUNC, X(MYRS),X1(MYRS),GRAD(MYRS),DLX0

      DLX0=FUNC(X)
      DO I=1,N
         X1(I)=X(I)
      END DO
      DO I=1,N
        X1(I)=X(I)+DH
        GRAD(I)=(FUNC(X1)-DLX0)/DH
        X1(I)=X(I)
      END DO
      RETURN
      END

      SUBROUTINE HESSP(FUNC,X,N,HESS)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

C  ARGS: FUNC = FUNCTION TO BE EVALUATED       X = N*1 VECTOR SPECIFYING X0

      PARAMETER (MYRS=200,MCOLS=40)
      EXTERNAL FUNC
      DOUBLE PRECISION HESS(MYRS,MYRS),X(MYRS), DH(MYRS),DAX0(MYRS),GRDD(MYRS)
      COMMON /nwt1/S,T(MYRS),iwork
      AMX=.01  !  COMPUTE STEP SIZE DH (BASED ON GAUSS PROC HESSP)
      DO I=1,N
        AX0=ABS(X(I))
        DAX0(I)=1
        IF (AX0 .GT. .0D0) DAX0(I)=X(I)/AX0
        IF(AX0 .GT. AMX)AMX=AX0
      END DO

      F0=FUNC(X)
      DO I=1,N
        DH(I)=.00001*AMX*DAX0(I)
        X(I)=X(I)+DH(I)
        GRDD(I)=FUNC(X)
        X(I)=X(I)-DH(I)
      END DO
C
      DO I=1,N
        DO J=I,N
          X(I)=X(I)+DH(I)
          X(J)=X(J)+DH(J)
          HESS(I,J)=(FUNC(X)-GRDD(J)-GRDD(I)+F0)/DH(I)/DH(J)
          HESS(J,I)=HESS(I,J)
          X(I)=X(I)-DH(I)
          X(J)=X(J)-DH(J)
        END DO
      END DO
      RETURN
      END
      SUBROUTINE NEWTON(FUNC,X,N,TOL,ISHOW,ISTEP,var)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

C MAXIMISES THE LIKELIHOOD FUNCTION 'FUNC' WITH RESPECT TO A VECTOR OF PARAMETERS X OF LENGTH N.  TOL DETERMINES THE CONVERGENCE
C CRITERION, ISHOW DETERMINES WHETHER THE ITERATIONS ARE PRINTED AND ISTEP IS THE MAXIMUM NUMBER OF STEPS TO TRY TO REACH CONVERGENCE

      PARAMETER (MYRS=200,MCOLS=40)
      EXTERNAL FUNC
      DOUBLE PRECISION FUNC,X(N),LASX(MYRS),step,var,HESS(MYRS,MYRS),GRAD(MYRS),PRD(MYRS),VCOV(MYRS,MYRS)
      COMMON /nwt1/S,T(MYRS),iwork
      iwork=0
      step=1.0
 105  if(iwork.eq.1) step=step/2.0d0
      if(iwork.eq.1) iwork=0
      if(step.lt.0.005d0) iwork=2
      if(iwork.eq.2) go to 100
      I=0
      DO 80 I=1,ISTEP
         DO J=1,N
            LASX(J)=X(J)
         END DO
         CALL GRADP(FUNC,X,N,GRAD)
         CALL HESSP(FUNC,X,N,HESS)
         if(iwork.eq.1) go to 110
         CALL INVERT(N,HESS,VCOV)  !  CALL MATINV(HESS,VCOV,N,MYRS)
         DO J=1,N
            PRD(J)=0.
            DO K=1,N
               PRD(J)=PRD(J)-VCOV(J,K)*GRAD(K)*step
            END DO
         END DO
         DO J=1,N
            X(J)=X(J)+PRD(J)
         END DO
         IF (I .GT. ISTEP) THEN
            PRINT *,'CONVERGENCE FAILURE'
            GOTO 100
         ENDIF
         DIST=0.
         DO J=1,N
            DIST=DIST+(LASX(J)-X(J))*(LASX(J)-X(J))
         END DO
         DIST=SQRT(DIST)
         IF(DIST.LE.TOL)GO TO 90
         IF(ISHOW.EQ.1) PRINT *,I,DIST,X,FUNC(X)
   80 CONTINUE
   90 CALL HESSP(FUNC,X,N,HESS)
      CALL INVERT(N,HESS,VCOV)   !   CALL MATINV(HESS,VCOV,N,MYRS)
      if(iwork.eq.1) go to 110
      DO I=1,N
         DO J=1,N
            VCOV(I,J)=-VCOV(I,J)
         END DO
      END DO
      var=vcov(1,1)
 110  if(iwork.gt.1) go to 100
      if(iwork.gt.0) go to 105
 100  RETURN
      END

