c  geninv.f      
      subroutine geninv(nsam,a,b)
      parameter (mcols=40)
      double precision a(mcols,mcols),b(mcols,mcols)
      INTEGER JOB,INFO,nsam
      
      REAL X(mcols,mcols),S(mcols),E(mcols),U(mcols,mcols),V(mcols,mcols),WORK(mcols)
      real eig(mcols,mcols),vpr(mcols,mcols),eigr(mcols,mcols)

      do i=1,mcols
         do j=1,mcols
            x(i,j)=real(a(i,j))  !   first, pass the matrix a to x  
         END DO
      END DO
      
      job=11
      call SSVDC(X,nsam,nsam,S,E,U,V,WORK,JOB,INFO)
      if (info.ne.0) then
        print *,'*********************************************'
        print *,' ERROR IN MATRIX INVERSE FUNCTION'
        print *,'*********************************************'
      end if

      eig=0 !  set up the diagonal matrix of eigenvalues
      do i=1,nsam
         if(s(i).gt.0.000001) eig(i,i)=1.0/s(i)
      end do

      vPR=transpose(v)  !   put them back together, transpose exp, u, mult u'exp'v      

      DO I=1,Nsam
         DO  J=1,Nsam
            eigr(I,J)=0.0
            DO  K=1,Nsam
               eigr(I,J)=eigr(I,J)+(u(I,K)*eig(K,J))
          end do
         end do
      end do
      DO I=1,Nsam
         DO J=1,Nsam
            u(I,J)=0.0
            DO K=1,Nsam
               u(I,J)=u(I,J)+(eigr(I,K)*vpr(K,J))
            end do
         end do
      end do
      x=transpose(u)  !        call TRANr(Nsam,Nsam,u,x)
      do i=1,nsam
         do j=1,nsam
            b(i,j)=x(i,j)
         end do
      end do
      return
      end 

      SUBROUTINE SSVDC(X,N,P,S,E,U,V,WORK,JOB,INFO)
      INTEGER N,P,JOB,INFO
      parameter (mcols=40)
      REAL X(mcols,mcols),S(mcols),E(mcols),U(mcols,mcols),V(mcols,mcols),WORK(mcols)

C     SSVDC IS A SUBROUTINE TO REDUCE A REAL NXP MATRIX X BY ORTHOGONAL TRANSFORMATIONS U AND V TO DIAGONAL FORM.  THE
C     DIAGONAL ELEMENTS S(I) ARE THE SINGULAR VALUES OF X.  THE COLUMNS OF U ARE THE CORRESPONDING LEFT SINGULAR VECTORS,
C     AND THE COLUMNS OF V THE RIGHT SINGULAR VECTORS.

C     ON ENTRY
C
C         X         REAL(LDX,P), WHERE LDX.GE.N.  X CONTAINS THE MATRIX WHOSE SINGULAR VALUE
C                   DECOMPOSITION IS TO BE COMPUTED.  X IS   DESTROYED BY SSVDC.
C
C         LDX       INTEGER.             LDX IS THE LEADING DIMENSION OF THE ARRAY X.
C
C         N         INTEGER.             N IS THE NUMBER OF COLUMNS OF THE MATRIX X.
C
C         P         INTEGER.             P IS THE NUMBER OF ROWS OF THE MATRIX X.
C
C         LDU       INTEGER.             LDU IS THE LEADING DIMENSION OF THE ARRAY U. (SEE BELOW).
C
C         LDV       INTEGER.             LDV IS THE LEADING DIMENSION OF THE ARRAY V. (SEE BELOW).
C
C         WORK      REAL(N).             WORK IS A SCRATCH ARRAY.
C
C         JOB       INTEGER.             JOB CONTROLS THE COMPUTATION OF THE SINGULAR  VECTORS.  IT HAS THE DECIMAL EXPANSION AB
C                   WITH THE FOLLOWING MEANING
C
C                        A.EQ.0    DO NOT COMPUTE THE LEFT SINGULAR VECTORS.
C                        A.EQ.1    RETURN THE N LEFT SINGULAR VECTORS IN U.
C                        A.GE.2    RETURN THE FIRST MIN(N,P) SINGULAR VECTORS IN U.
C                        B.EQ.0    DO NOT COMPUTE THE RIGHT SINGULAR VECTORS.
C                        B.EQ.1    RETURN THE RIGHT SINGULAR VECTORS IN V.
C
C     ON RETURN
C
C         S         REAL(MM), WHERE MM=MIN(N+1,P). THE FIRST MIN(N,P) ENTRIES OF S CONTAIN THE
C                   SINGULAR VALUES OF X ARRANGED IN DESCENDING ORDER OF MAGNITUDE.
C
C         E         REAL(P).           E ORDINARILY CONTAINS ZEROS.  HOWEVER SEE THE DISCUSSION OF INFO FOR EXCEPTIONS.
C
C         U         REAL(LDU,K), WHERE LDU.GE.N.  IF JOBA.EQ.1 THEN  K.EQ.N,
c                                                 IF JOBA.GE.2 THEN  K.EQ.MIN(N,P).
C                   U CONTAINS THE MATRIX OF RIGHT SINGULAR VECTORS.
C                   U IS NOT REFERENCED IF JOBA.EQ.0.  IF N.LE.P  OR IF JOBA.EQ.2, THEN U MAY BE IDENTIFIED WITH X IN THE SUBROUTINE CALL.
C
C         V         REAL(LDV,P), WHERE LDV.GE.P.  V CONTAINS THE MATRIX OF RIGHT SINGULAR VECTORS.
C                   V IS NOT REFERENCED IF JOB.EQ.0.  IF P.LE.N, THEN V MAY BE IDENTIFIED WITH X IN THE SUBROUTINE CALL.
C
C         INFO      INTEGER.
C                   THE SINGULAR VALUES (AND THEIR CORRESPONDING SINGULAR VECTORS) S(INFO+1),S(INFO+2),...,S(M)
C                   ARE CORRECT (HERE M=MIN(N,P)).  THUS IF INFO.EQ.0, ALL THE SINGULAR VALUES AND THEIR VECTORS ARE CORRECT.
c                   IN ANY EVENT, THE MATRIX  B = TRANS(U)*X*V IS THE BIDIAGONAL MATRIX WITH THE ELEMENTS OF S ON ITS DIAGONAL AND THE
C                   ELEMENTS OF E ON ITS SUPER-DIAGONAL (TRANS(U)  IS THE TRANSPOSE OF U).  THUS THE SINGULAR VALUES OF X AND B ARE THE SAME.
C
C     LINPACK. THIS VERSION DATED 03/19/79 .  G.W. STEWART, UNIVERSITY OF MARYLAND, ARGONNE NATIONAL LAB.
C
C     ***** USES THE FOLLOWING FUNCTIONS AND SUBPROGRAMS.
C
C     EXTERNAL SROT
C     BLAS SAXPY,SDOT,SSCAL,SSWAP,SNRM2,SROTG
C     FORTRAN ABS,AMAX1,MAX0,MIN0,MOD,SQRT
C
C     INTERNAL VARIABLES
C
      INTEGER I,ITER,J,JOBU,K,KASE,KK,L,LL,LLS,LM1,LP1,LS,LU,M,MAXIT, MM,MM1,MP1,NCT,NCTP1,NCU,NRT,NRTP1
      REAL SDOT,T,B,C,CS,EL,EMM1,F,G,SNRM2,SCALE,SHIFT,SL,SM,SN,SMM1,T1,TEST,ZTEST
      LOGICAL WANTU,WANTV

      MAXIT = 30  !     SET THE MAXIMUM NUMBER OF ITERATIONS.
      WANTU = .FALSE.   !     DETERMINE WHAT IS TO BE COMPUTED.
      WANTV = .FALSE.
      JOBU = MOD(JOB,100)/10
      NCU = N
      IF (JOBU .GT. 1) NCU = MIN0(N,P)
      IF (JOBU .NE. 0) WANTU = .TRUE.
      IF (MOD(JOB,10) .NE. 0) WANTV = .TRUE.

C     REDUCE X TO BIDIAGONAL FORM, STORING THE DIAGONAL ELEMENTS  IN S AND THE SUPER-DIAGONAL ELEMENTS IN E.

      INFO = 0
      NCT = MIN0(N-1,P)
      NRT = MAX0(0,MIN0(P-2,N))
      LU = MAX0(NCT,NRT)
      IF (LU .GE. 1) THEN
      DO L = 1, LU
         LP1 = L + 1
         IF (L .LE. NCT) THEN
            S(L) = SNRM2(N-L+1,X(L,L),1)  ! COMPUTE THE TRANSFORMATION FOR THE L-TH COLUMN AND PLACE THE L-TH DIAGONAL IN S(L).
            IF (S(L) .NE. 0.0E0) THEN
               IF (X(L,L) .NE. 0.0E0) S(L) = SIGN(S(L),X(L,L))
               CALL SSCAL(N-L+1,1.0E0/S(L),X(L,L),1)
               X(L,L) = 1.0E0 + X(L,L)
            END IF
            S(L) = -S(L)
         END IF
         IF (P .GE. LP1) THEN
            DO J = LP1, P
               IF (L .LE. NCT) THEN
                  IF (S(L) .NE. 0.0E0) THEN
                     T = -SDOT(N-L+1,X(L,L),1,X(L,J),1)/X(L,L)  ! APPLY THE TRANSFORMATION.
                     CALL SAXPY(N-L+1,T,X(L,L),1,X(L,J),1)
                  END IF
               END IF
               E(J) = X(L,J)  ! PLACE THE L-TH ROW OF X INTO  E FOR THE  SUBSEQUENT CALCULATION OF THE ROW TRANSFORMATION.
            END DO
         END IF
         IF (WANTU .AND. L .LE. NCT) THEN
            DO I = L, N  !   PLACE THE TRANSFORMATION IN U FOR SUBSEQUENT BACK MULTIPLICATION.
               U(I,L) = X(I,L)
            END DO
         END IF
         IF (L .LE. NRT) THEN
            E(L) = SNRM2(P-L,E(LP1),1)  ! COMPUTE THE L-TH ROW TRANSFORMATION AND PLACE THE L-TH SUPER-DIAGONAL IN E(L).
            IF (E(L) .NE. 0.0E0) THEN
               IF (E(LP1) .NE. 0.0E0) E(L) = SIGN(E(L),E(LP1))
               CALL SSCAL(P-L,1.0E0/E(L),E(LP1),1)
               E(LP1) = 1.0E0 + E(LP1)
            END IF
            E(L) = -E(L)
            IF (LP1 .LE. N .AND. E(L) .NE. 0.0E0) THEN
               DO I = LP1, N  !    APPLY THE TRANSFORMATION.
                  WORK(I) = 0.0E0
               END DO
               DO J = LP1, P
                  CALL SAXPY(N-L,E(J),X(LP1,J),1,WORK(LP1),1)
               END DO
               DO J = LP1, P
                  CALL SAXPY(N-L,-E(J)/E(LP1),WORK(LP1),1,X(LP1,J),1)
               END DO
            END IF
            IF (WANTV) THEN
               DO I = LP1, P  !   PLACE THE TRANSFORMATION IN V FOR SUBSEQUENT BACK MULTIPLICATION.
                  V(I,L) = E(I)
               END DO
            END IF
         END IF
      END DO
      END IF

      M = MIN0(P,N+1)  !    SET UP THE FINAL BIDIAGONAL MATRIX OR ORDER M.
      NCTP1 = NCT + 1
      NRTP1 = NRT + 1
      IF (NCT .LT. P) S(NCTP1) = X(NCTP1,NCTP1)
      IF (N .LT. M) S(M) = 0.0E0
      IF (NRTP1 .LT. M) E(NRTP1) = X(NRTP1,M)
      E(M) = 0.0E0

      IF (WANTU) THEN  !    IF REQUIRED, GENERATE U.
         IF (NCU .GE. NCTP1) THEN
            DO J = NCTP1, NCU
               DO I = 1, N
                  U(I,J) = 0.0E0
               END DO
               U(J,J) = 1.0E0
            END DO
         END IF
         IF (NCT .GE. 1) THEN
            DO LL = 1, NCT
               L = NCT - LL + 1
               IF (S(L) .NE. 0.0E0) THEN
                  LP1 = L + 1
                  IF (NCU .GE. LP1) THEN
                     DO J = LP1, NCU
                       T = -SDOT(N-L+1,U(L,L),1,U(L,J),1)/U(L,L)
                       CALL SAXPY(N-L+1,T,U(L,L),1,U(L,J),1)
                     END DO
                  END IF
                  CALL SSCAL(N-L+1,-1.0E0,U(L,L),1)
                  U(L,L) = 1.0E0 + U(L,L)
                  LM1 = L - 1
                  IF (LM1 .GE. 1) THEN
                     DO I = 1, LM1
                        U(I,L) = 0.0E0
                     END DO
                  END IF
               ELSE
                  DO I = 1, N
                     U(I,L) = 0.0E0
                  END DO
                  U(L,L) = 1.0E0
               END IF
            END DO
         END IF
      END IF

      IF (WANTV) THEN  !  IF IT IS REQUIRED, GENERATE V.
         DO LL = 1, P
            L = P - LL + 1
            LP1 = L + 1
            IF (L .LE. NRT) THEN
               IF (E(L) .NE. 0.0E0) THEN
                  DO J = LP1, P
                     T = -SDOT(P-L,V(LP1,L),1,V(LP1,J),1)/V(LP1,L)
                     CALL SAXPY(P-L,T,V(LP1,L),1,V(LP1,J),1)
                  END DO
               END IF
            END IF
            DO I = 1, P
               V(I,L) = 0.0E0
            END DO
            V(L,L) = 1.0E0
         END DO
      END IF

C     MAIN ITERATION LOOP FOR THE SINGULAR VALUES.

      MM = M
      ITER = 0
  360 CONTINUE

C        QUIT IF ALL THE SINGULAR VALUES HAVE BEEN FOUND.

C     ...EXIT
         IF (M .EQ. 0) GO TO 620

C        IF TOO MANY ITERATIONS HAVE BEEN PERFORMED, SET FLAG AND RETURN.

         IF (ITER .LT. MAXIT) GO TO 370
            INFO = M
C     ......EXIT
            GO TO 620
  370    CONTINUE

C        THIS SECTION OF THE PROGRAM INSPECTS FOR NEGLIGIBLE ELEMENTS IN THE S AND E ARRAYS. ON COMPLETION THE VARIABLES KASE AND L ARE SET AS FOLLOWS.

C           KASE = 1     IF S(M) AND E(L-1) ARE NEGLIGIBLE AND L.LT.M
C           KASE = 2     IF S(L) IS NEGLIGIBLE AND L.LT.M
C           KASE = 3     IF E(L-1) IS NEGLIGIBLE, L.LT.M, AND S(L), ..., S(M) ARE NOT NEGLIGIBLE (QR STEP).
C           KASE = 4     IF E(M-1) IS NEGLIGIBLE (CONVERGENCE).

         DO LL = 1, M
            L = M - LL
            IF (L .EQ. 0) exit
            TEST = ABS(S(L)) + ABS(S(L+1))
            ZTEST = TEST + ABS(E(L))
            IF (ZTEST .eq. TEST) THEN
               E(L) = 0.0E0
               exit
            END IF
         END DO

         IF (L .EQ. (M - 1)) THEN
            KASE = 4
         ELSE
            LP1 = L + 1
            MP1 = M + 1
            DO LLS = LP1, MP1
               LS = M - LLS + LP1
               IF (LS .EQ. L) EXIT
               TEST = 0.0E0
               IF (LS .NE. M) TEST = TEST + ABS(E(LS))
               IF (LS .NE. L + 1) TEST = TEST + ABS(E(LS-1))
               ZTEST = TEST + ABS(S(LS))
               IF (ZTEST .EQ. TEST) THEN
                  S(LS) = 0.0E0
                  EXIT
               END IF
            END DO
            IF (LS .EQ. L) THEN
               KASE = 3
            ELSE
               IF (LS .EQ. M) THEN
                  KASE = 1
               ELSE
                  KASE = 2
                  L = LS
               END IF
            END IF
         END IF
         L = L + 1

C        PERFORM THE TASK INDICATED BY KASE.

         GO TO (490,520,540,570), KASE

  490       MM1 = M - 1            !   DEFLATE NEGLIGIBLE S(M).
            F = E(M-1)
            E(M-1) = 0.0E0
            DO KK = L, MM1
               K = MM1 - KK + L
               T1 = S(K)
               CALL SROTG(T1,F,CS,SN)
               S(K) = T1
               IF (K .NE. L) THEN
                  F = -SN*E(K-1)
                  E(K-1) = CS*E(K-1)
               END IF
               IF (WANTV) CALL SROT(P,V(1,K),1,V(1,M),1,CS,SN)
            END DO
         GO TO 610

  520       F = E(L-1)  !    SPLIT AT NEGLIGIBLE S(L).
            E(L-1) = 0.0E0
            DO K = L, M
               T1 = S(K)
               CALL SROTG(T1,F,CS,SN)
               S(K) = T1
               F = -SN*E(K)
               E(K) = CS*E(K)
               IF (WANTU) CALL SROT(N,U(1,K),1,U(1,L-1),1,CS,SN)
            END DO
         GO TO 610

  540       SCALE = AMAX1(ABS(S(M)),ABS(S(M-1)),ABS(E(M-1)),ABS(S(L)),ABS(E(L)))  !    PERFORM ONE QR STEP.  CALCULATE THE SHIFT.
            SM = S(M)/SCALE
            SMM1 = S(M-1)/SCALE
            EMM1 = E(M-1)/SCALE
            SL = S(L)/SCALE
            EL = E(L)/SCALE
            B = ((SMM1 + SM)*(SMM1 - SM) + EMM1**2)/2.0E0
            C = (SM*EMM1)**2
            SHIFT = 0.0E0
            IF (B .NE. 0.0E0 .OR. C .NE. 0.0E0) THEN
               SHIFT = SQRT(B**2+C)
               IF (B .LT. 0.0E0) SHIFT = -SHIFT
               SHIFT = C/(B + SHIFT)
            END IF
            F = (SL + SM)*(SL - SM) + SHIFT
            G = SL*EL

            MM1 = M - 1  !   CHASE ZEROS.
            DO K = L, MM1
               CALL SROTG(F,G,CS,SN)
               IF (K .NE. L) E(K-1) = F
               F = CS*S(K) + SN*E(K)
               E(K) = CS*E(K) - SN*S(K)
               G = SN*S(K+1)
               S(K+1) = CS*S(K+1)
               IF (WANTV) CALL SROT(P,V(1,K),1,V(1,K+1),1,CS,SN)
               CALL SROTG(F,G,CS,SN)
               S(K) = F
               F = CS*E(K) + SN*S(K+1)
               S(K+1) = -SN*E(K) + CS*S(K+1)
               G = SN*E(K+1)
               E(K+1) = CS*E(K+1)
               IF (WANTU .AND. K .LT. N) CALL SROT(N,U(1,K),1,U(1,K+1),1,CS,SN)
            END DO
            E(M-1) = F
            ITER = ITER + 1
         GO TO 610

  570    CONTINUE  !    CONVERGENCE.      MAKE THE SINGULAR VALUE  POSITIVE.

            IF (S(L) .LT. 0.0E0) THEN
               S(L) = -S(L)
               IF (WANTV) CALL SSCAL(P,-1.0E0,V(1,L),1)
            END IF

C           ORDER THE SINGULAR VALUE.

            DO WHILE (L .NE. MM) 
               IF (S(L) .GE. S(L+1)) EXIT
               T = S(L)
               S(L) = S(L+1)
               S(L+1) = T
               IF (WANTV .AND. L .LT. P) CALL SSWAP(P,V(1,L),1,V(1,L+1),1)
               IF (WANTU .AND. L .LT. N) CALL SSWAP(N,U(1,L),1,U(1,L+1),1)
               L = L + 1
            END DO
            ITER = 0
            M = M - 1
  610    CONTINUE
      GO TO 360
  620 CONTINUE
      RETURN
      END

      REAL FUNCTION SNRM2 ( N, SX, INCX)
      INTEGER          NEXT
      REAL   SX(1),  CUTLO, CUTHI, HITEST, SUM, XMAX, ZERO, ONE

C   SMALL is used to prevent values below SMALL from being returned. See the end of the program for usage.
      REAL SMALL
      DATA SMALL / 8.43E-37 /
      DATA ZERO, ONE /0.0E0, 1.0E0/

C     EUCLIDEAN NORM OF THE N-VECTOR STORED IN SX() WITH STORAGE INCREMENT INCX .
C     IF    N .LE. 0 RETURN WITH RESULT = 0.
C     IF N .GE. 1 THEN INCX MUST BE .GE. 1

C           C.L.LAWSON, 1978 JAN 08

C     FOUR PHASE METHOD     USING TWO BUILT-IN CONSTANTS THAT ARE  HOPEFULLY APPLICABLE TO ALL MACHINES.
C         CUTLO = MAXIMUM OF  SQRT(U/EPS)  OVER ALL KNOWN MACHINES.
C         CUTHI = MINIMUM OF  SQRT(V)      OVER ALL KNOWN MACHINES.
C     WHERE
C         EPS = SMALLEST NO. SUCH THAT EPS + 1. .GT. 1.
C         U   = SMALLEST POSITIVE NO.   (UNDERFLOW LIMIT)
C         V   = LARGEST  NO.            (OVERFLOW  LIMIT)
C
C     BRIEF OUTLINE OF ALGORITHM..
C
C     PHASE 1    SCANS ZERO COMPONENTS.
C     MOVE TO PHASE 2 WHEN A COMPONENT IS NONZERO AND .LE. CUTLO
C     MOVE TO PHASE 3 WHEN A COMPONENT IS .GT. CUTLO
C     MOVE TO PHASE 4 WHEN A COMPONENT IS .GE. CUTHI/M
C     WHERE M = N FOR X() REAL AND M = 2*N FOR COMPLEX.
C
C     VALUES FOR CUTLO AND CUTHI..
C     FROM THE ENVIRONMENTAL PARAMETERS LISTED IN THE IMSL CONVERTER DOCUMENT THE LIMITING VALUES ARE AS FOLLOWS..
C     CUTLO, S.P.   U/EPS = 2**(-102) FOR  HONEYWELL.  CLOSE SECONDS ARE UNIVAC AND DEC AT 2**(-103) THUS CUTLO = 2**(-51) = 4.44089E-16
C     CUTHI, S.P.   V = 2**127 FOR UNIVAC, HONEYWELL, AND DEC. THUS CUTHI = 2**(63.5) = 1.30438E19
C     CUTLO, D.P.   U/EPS = 2**(-67) FOR HONEYWELL AND DEC.   THUS CUTLO = 2**(-33.5) = 8.23181D-11
C     CUTHI, D.P.   SAME AS S.P.  CUTHI = 1.30438D19
C     DATA CUTLO, CUTHI / 8.232D-11,  1.304D19 /
C     DATA CUTLO, CUTHI / 4.441E-16,  1.304E19 /
      DATA CUTLO, CUTHI / 4.441E-16,  1.304E19 /

      IF(N .GT. 0) GO TO 10
         SNRM2  = ZERO
         GO TO 300

c   10 ASSIGN 30 TO NEXT
  10  next=30
      SUM = ZERO
      NN = N * INCX
C                                  GIN MAIN LOOP
      I = 1
c 20  GO TO NEXT,(30, 50, 70, 110)
  20  if(next.eq.50) goto 50
      if(next.eq.70) goto 70
      if(next.eq.110) goto 110
      IF( ABS(SX(I)) .GT. CUTLO) GO TO 85
      next=50
      XMAX = ZERO
C                        PHASE 1.  SUM IS ZERO

   50 IF( SX(I) .EQ. ZERO) GO TO 200
      IF( ABS(SX(I)) .GT. CUTLO) GO TO 85

C                                PREPARE FOR PHASE 2.
      next=70
      GO TO 105
C                                PREPARE FOR PHASE 4.
  100 I = J
      next=110
      SUM = (SUM / SX(I)) / SX(I)
  105 XMAX = ABS(SX(I))
      GO TO 115

C                   PHASE 2.  SUM IS SMALL.  SCALE TO AVOID DESTRUCTIVE UNDERFLOW.

   70 IF( ABS(SX(I)) .GT. CUTLO ) GO TO 75

C                     COMMON CODE FOR PHASES 2 AND 4. IN PHASE 4 SUM IS LARGE.  SCALE TO AVOID OVERFLOW.

  110 IF( ABS(SX(I)) .LE. XMAX ) GO TO 115
         SUM = ONE + SUM * (XMAX / SX(I))**2
         XMAX = ABS(SX(I))
         GO TO 200

  115 SUM = SUM + (SX(I)/XMAX)**2
      GO TO 200

C                  PREPARE FOR PHASE 3.

   75 SUM = (SUM * XMAX) * XMAX

C     FOR REAL OR D.P. SET HITEST = CUTHI/N
C     FOR COMPLEX      SET HITEST = CUTHI/(2*N)

   85 HITEST = CUTHI/FLOAT( N )

C                   PHASE 3.  SUM IS MID-RANGE.  NO SCALING.

      DO 95 J =I,NN,INCX
         IF(ABS(SX(J)) .GE. HITEST) GO TO 100
         SUM = SUM + SX(J)**2
   95 continue
      SNRM2 = SQRT( SUM )
      GO TO 300

  200 CONTINUE
      I = I + INCX
      IF ( I .LE. NN ) GO TO 20

C              END OF MAIN LOOP.
      SNRM2 = XMAX * SQRT(SUM)  !   COMPUTE SQUARE ROOT AND ADJUST FOR SCALING.
  300 CONTINUE

C *** 6 Jan 84, J. Fried : 
C     This next line of FORTRAN was added to prevent values below MS-FORTRAN's specified minimum from being returned.  Such 
C     numbers have appeared during testing of the SQRDC routine (test #9 in SQ).  The value of SMALL was taken from the 
C     MS-FORTRAN manual.  Remember, this only applies to PC/MS-FORTRAN.

      IF ( SNRM2 .LE. SMALL ) SNRM2 = SMALL
      RETURN
      END

      SUBROUTINE  SSCAL(N,DA,DX,INCX)

C     SCALES A VECTOR BY A CONSTANT. USES UNROLLED LOOPS FOR INCREMENT EQUAL TO ONE.  JACK DONGARRA, LINPACK, 3/11/78.

      REAL DA,DX(1)
      INTEGER I,INCX,M,MP1,N,NINCX
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1)GO TO 20
      NINCX = N*INCX  !         CODE FOR INCREMENT NOT EQUAL TO 1
      DO I = 1,NINCX,INCX
        DX(I) = DA*DX(I)
      END DO
      RETURN

C        CODE FOR INCREMENT EQUAL TO 1.       CLEAN-UP LOOP

   20 M = MOD(N,5)
      IF( M .EQ. 0 ) GO TO 40
      DO I = 1,M
        DX(I) = DA*DX(I)
      END DO
      IF( N .LT. 5 ) RETURN
   40 MP1 = M + 1
      DO I = MP1,N,5
        DX(I) = DA*DX(I)
        DX(I + 1) = DA*DX(I + 1)
        DX(I + 2) = DA*DX(I + 2)
        DX(I + 3) = DA*DX(I + 3)
        DX(I + 4) = DA*DX(I + 4)
      END DO
      RETURN
      END

      REAL FUNCTION SDOT(N,SX,INCX,SY,INCY)  ! FORMS THE DOT PRODUCT OF TWO VECTORS.  USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.  JACK DONGARRA, LINPACK, 3/11/78.

      REAL SX(1),SY(1),TEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N

      SDOT = 0.0E0
      TEMP = 0.0E0
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20

C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL TO 1

      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
        TEMP = TEMP + SX(IX)*SY(IY)
        IX = IX + INCX
        IY = IY + INCY
   10 CONTINUE
      SDOT = TEMP
      RETURN
   20 M = MOD(N,5)  !         CODE FOR BOTH INCREMENTS EQUAL TO 1.    CLEAN-UP LOOP
      IF( M .EQ. 0 ) GO TO 40
      DO I = 1,M
        TEMP = TEMP + SX(I)*SY(I)
      END DO
      IF( N .LT. 5 ) GO TO 60
   40 MP1 = M + 1
      DO I = MP1,N,5
        TEMP = TEMP + SX(I)*SY(I) + SX(I + 1)*SY(I + 1) + SX(I + 2)*SY(I + 2) + SX(I + 3)*SY(I + 3) + SX(I + 4)*SY(I + 4)
      END DO
   60 SDOT = TEMP
      RETURN
      END

      SUBROUTINE SAXPY(N,SA,SX,INCX,SY,INCY)  !  CONSTANT TIMES A VECTOR PLUS A VECTOR.  USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO ONE.
C                                                   JACK DONGARRA, LINPACK, 3/11/78.

      REAL SX(1),SY(1),SA
      INTEGER I,INCX,INCY,M,MP1,N

      IF(N.LE.0)RETURN
      IF (SA .EQ. 0.0E0) RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20

C        CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL TO 1

      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO I = 1,N
        SY(IY) = SY(IY) + SA*SX(IX)
        IX = IX + INCX
        IY = IY + INCY
      END DO
      RETURN

c        CODE FOR BOTH INCREMENTS EQUAL TO 1.    CLEAN-UP LOOP

   20 M = MOD(N,4)
      IF( M .EQ. 0 ) GO TO 40
      DO I = 1,M
        SY(I) = SY(I) + SA*SX(I)
      END DO
      IF( N .LT. 4 ) RETURN
   40 MP1 = M + 1
      DO I = MP1,N,4
        SY(I) = SY(I) + SA*SX(I)
        SY(I + 1) = SY(I + 1) + SA*SX(I + 1)
        SY(I + 2) = SY(I + 2) + SA*SX(I + 2)
        SY(I + 3) = SY(I + 3) + SA*SX(I + 3)
      END DO
      RETURN
      END

      SUBROUTINE SROTG(SA,SB,C,S) !    CONSTRUCT GIVENS PLANE ROTATION.  JACK DONGARRA, LINPACK, 3/11/78.

      REAL SA,SB,C,S,ROE,SCALE,R,Z

      ROE = SB
      IF( ABS(SA) .GT. ABS(SB) ) ROE = SA
      SCALE = ABS(SA) + ABS(SB)
      IF( SCALE .EQ. 0.0 ) THEN
         C = 1.0
         S = 0.0
         R = 0.0
      ELSE 
        R = SCALE*SQRT((SA/SCALE)**2 + (SB/SCALE)**2)
        R = SIGN(1.0,ROE)*R
        C = SA/R
        S = SB/R
      END IF
      Z = 1.0
      IF( ABS(SA) .GT. ABS(SB) ) Z = S
      IF( ABS(SB) .GE. ABS(SA) .AND. C .NE. 0.0 ) Z = 1.0/C
      SA = R
      SB = Z
      RETURN
      END

      SUBROUTINE SROT (N,SX,INCX,SY,INCY,C,S)  !    APPLIES A PLANE ROTATION. JACK DONGARRA, LINPACK, 3/11/78.

      REAL SX(1),SY(1),STEMP,C,S
      INTEGER I,INCX,INCY,IX,IY,N

      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20

C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL TO 1

      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO I = 1,N
        STEMP = C*SX(IX) + S*SY(IY)
        SY(IY) = C*SY(IY) - S*SX(IX)
        SX(IX) = STEMP
        IX = IX + INCX
        IY = IY + INCY
      END DO
      RETURN

C       CODE FOR BOTH INCREMENTS EQUAL TO 1

   20 DO I = 1,N
        STEMP = C*SX(I) + S*SY(I)
        SY(I) = C*SY(I) - S*SX(I)
        SX(I) = STEMP
      END DO
      RETURN
      END

      SUBROUTINE SSWAP (N,SX,INCX,SY,INCY)

C     INTERCHANGES TWO VECTORS. USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO 1.  JACK DONGARRA, LINPACK, 3/11/78.

      REAL SX(1),SY(1),STEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N

      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20

C       CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL TO 1

      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO I = 1,N
        STEMP = SX(IX)
        SX(IX) = SY(IY)
        SY(IY) = STEMP
        IX = IX + INCX
        IY = IY + INCY
      END DO
      RETURN

C       CODE FOR BOTH INCREMENTS EQUAL TO 1
C       CLEAN-UP LOOP

   20 M = MOD(N,3)
      IF( M .EQ. 0 ) GO TO 40
      DO I = 1,M
        STEMP = SX(I)
        SX(I) = SY(I)
        SY(I) = STEMP
      END DO
      IF( N .LT. 3 ) RETURN
   40 MP1 = M + 1
      DO I = MP1,N,3
        STEMP = SX(I)
        SX(I) = SY(I)
        SY(I) = STEMP
        STEMP = SX(I + 1)
        SX(I + 1) = SY(I + 1)
        SY(I + 1) = STEMP
        STEMP = SX(I + 2)
        SX(I + 2) = SY(I + 2)
        SY(I + 2) = STEMP
      END DO
      RETURN
      END

