indelois <- function(n,ncol,rtnow,stanow,strnow,des,cnt,aou,yrf,yrl,blues,backm,xsum,alt){

    #    this is a semiparametric smooth ala the instructions  of hasti and timsurabi, as given in james et al (1995)
    #    in this version,  "robust" loess is not used.   no transform of data before analysis
    #^^^note that yrf and yrl are passed

    #  this subroutine prints out the design matrix and counts to  an output file for the index analysis  jrs 22 may 1987.

    nn=n;  nncol=ncol; myrs=max(des[,2]-(yrf-1)); fx=fy=rep(0,myrs)
    
    #  minimum data check (use the james criteria)

    oof=0.5 #  set tension parameter (oof) to 0.5

    cmin=minwt(nn,nncol,des,cnt,yrf)
    if((cmin < 0) && (alt != 5)) blues=-9998
    if(alt == 5)  cat('time series of species data\nyear\ncount\n')

    # routes that reach here are ok 
    yrs2=1:myrs; lcnt=lcnt3=rep(-1,myrs); iobs=cor2=cor1=rep(0,myrs)    
      #    set up 2 matrices with years from 1 to myrs into lcnt,
      #    put the counts (-1=missing) into iobs, put the observer number
      #    first set all counts to -1 and all obs to blanks
 
    nonzero=xsum=a1=an1=a2=an2=0
       #  now go through the data for the route and put it in matrices
    
    k=floor(des[,2]-(yrf-1))  #   find the year for this one (note years start at yrf)
    xsum=sum(exp(cnt)-0.5)      #  lcnt and g have years missing in them ^^^^^^^^
    if(nncol == 2) iobs[k]=1    #  ^^^^^^^^^^^^^^^^^^^^^^^^^^^
    dmin=min(des[,2])
    dmax=max(des[,2])
    yrs2[1:nrow(des)]=des[,2]-(yrf-1)
    g=matrix(0, max(k), nncol)
    lcnt[k]=exp(cnt)-0.5; a1=a1n=a2=a2n=0
    #a1=sum(lcnt[(des[,2] >= 66) && (des[,2] <= 70.1)])
    #an1=sum(    (des[,2] >= 66) && (des[,2] <= 70.1))
    #a2=sum(lcnt[(des[,2] >= 91) && (des[,2] <= 95.1)])
    #an2=sum(    (des[,2] >= 91) && (des[,2] <= 95.1))
    lcnt3=lcnt    #    lcnt3 is a storage for the raw data for all years   
    g[k,]=des     #    put the data for year k into the matrix g  
    
    if(nncol > 2) {
       ii=apply(des,1,function(v){i=which(v>=1);i[length(i)]})
       iobs[k]=ii-2
    }
    iobs[iobs==0]=nncol-1; nonzero=sum(lcnt>0.9)
    if(an1 > 0) a1=a1/an1
    if(an2 > 0) a2=a2/an2
    xsum=xsum/(nn)

    #  now, data are in the matrix.  get rid of the missing years for input to the loess
    
    numdat=0; lcnt2=yrs3=rep(0,myrs); des3=matrix(0, myrs, nncol-1)
    for (i in 1: myrs) {
        if(lcnt[i] > -1) {
            numdat=numdat+1; lcnt2[numdat]=lcnt[i]
            ifff=0; yrs3[numdat]=g[i,2]-(yrf-1)
            des3[numdat,]=g[i,-2]
            ifff=sum(des3[numdat,2:(nncol-1)]>0)
            if(ifff >0) des3[numdat,1]=0  #  here we set up the final observer, and replace the first row of ones with its data
        }
        lcnt[i]=-1.
    }
    
    if(alt == 5) iadd=floor(dmax-dmin)+1
    # ^^^*here is the trap for minwt###########
    if(cmin < 0) return(list(alt=alt, xsum=xsum, backm=backm, blues=blues))
    #    we should now be ready to xcall=lois
    cor1=lcnt2;  yrs=yrs3;
    if (nncol > 2) {
    #  now, the input files lcnt2 and des3 contain the data, for numdat years  no missing data in it.
        g=matrix(0,numdat,nncol); sumg=rep(0,myrs)          #    now set g[i,j] =0
        amax=max(yrs)  # for the year column yrs is indexed to yrf=1
        lcnt=rep(0,numdat)
        for (i in 1:nncol) {                                 #    semiparametric stuff.
            if(i == nncol) sumg=lcnt2 else sumg=des3[,i]
            xcall=loess(yrs,sumg,numdat,lcnt,yrs2,yrf,yrl,oof)  # now smooth sumg vs yrs[j]
            fx=xcall$fx; fy=xcall$fy; lcnt=xcall$lcnt
            
    #  now have to omit the years that are missing in yrs...  this includes missing intermediate yrs and beyond endpoints
    #  smooth is done, now update g
            jj=1
            for (j in 1:numdat) {
                if(yrs2[j] >= yrs[jj]) {  #  if yrs doesn't equal yrs2, skip it
                    g[jj,i]=lcnt[j]
                    if(i == nncol) lcnt[jj]=lcnt[j]
                    jj=jj+1
                }
            }
            #continue
            if(jj == 1) cat('loes switch back did not work!\n')
        }
    #   ^^^*  end of loop for each column of the x matrix ^^^^*

    #        all columns are done- check if converged
    #        calculate the adjusted smooth (without missing years)
    #        now, find xres and yres
        for (i in 1:numdat) {
            lcnt[i]=lcnt2[i]-lcnt[i]
            for (j in 1:nncol) if(j < nncol) g[i,j]=des3[i,j]-g[i,j]
        }
    #        now, g and lcnt and the yres and xres matrices    now find betahat= (x'xres)-1 (x'yres)
        
        des3=des3[1:numdat,1:(nncol-1)]; g=g[1:numdat,1:(nncol-1)]
        xpr=t(des3)                  #  find the x prime matrix xprc
        xpx=xpr %*% g                #  find the x prime-x matrix
        if((xpx[1,1] <= -9998) && (oof >= 0.75)) {
            a7<<-c(a7,paste(aou, stanow, rtnow,'second malmlt fail x-x'))
            return(list(alt=alt, xsum=xsum, backm=backm, blues=blues))
        }
        xpxinv=ginv(xpx)            #  find the x prime x inverse matrix
        xpy=xpr %*% lcnt[1:numdat]             #  find the x prime y vector
        if((xpy[1] <= -9998) && (oof >= 0.75)) a7<<-c(a7,paste(aou, stanow, rtnow,'second malmlt fail x-y'))
        bmat=xpxinv %*% xpy          # find the b vector (x'x)-1 (x'y)
        if((bmat[1,1] <= -9998) && (oof >= 0.75)) a7<<-c(a7,paste(aou, stanow, rtnow,' second malmlt fail at b'))

    #        so bmat is the beta for the smoothed variables. find y-x*bmat

        cor2=des3 %*% bmat           # find the x bmat vector, xcall=it xpy for now
        if((cor2[1] <= -9998) && (oof >= 0.75)) {
            a7<<-c(a7,paste(aou, stanow, rtnow,'second malmlt fail-x-b'))
            return(list(alt=alt, xsum=xsum, backm=backm, blues=blues))
        }
        cor1[1:numdat]=lcnt2[1:numdat]-cor2[1:numdat]
        yrs[1:numdat]=yrs3[1:numdat]
        lcnt[1:numdat]=-1.0
    #        ^^ end of semiparametric loop ^^^^^^^^^^^*
    }

    #  now do a final loess on the data.  here, redefine yrs2 to be from min to max
    yrs2[1:(nn+iadd)]=(dmin-yrf+1)+(1:(nn+iadd)-1)

    xcall=loess(yrs,cor1,numdat,lcnt,yrs2,yrf,yrl,oof)
    fx=xcall$fx; fy=xcall$fy; lcnt=xcall$lcnt

    if(alt == 5) {
        for (i in 1:iadd) cat(sprintf('%7.2f %12.4f\n',yrs2[i]+yrf-1,lcnt[i]))

        if(lcnt[1+2] <= 0) lcnt[iadd-2]=lcnt[iadd-2]+0.1  #     these 1+2, iadd -2 are indexes for the "endpoints"  
        if(lcnt[1+2] <= 0) lcnt[1+2]=0.1
        if(lcnt[iadd-2] <= 0) lcnt[1+2]=lcnt[1+2]+0.1
        if(lcnt[iadd-2] <= 0) lcnt[iadd-2]=0.1
        blues=(((lcnt[iadd-2]/lcnt[1+2])^(1/(yrs2[iadd-2]-yrs2[1+2])))-1)*100

        cat(sprintf('<p>loess:  %6.2f   (over interval %5.0f to %5.0f)\n',
           blues, yrs2[1+2]+yrf-1.0, yrs2[iadd-2]+yrf-1.0)) 
    }
    numfin=nonz=atot=xsumyr=anonz=totyr=s1=s2=0
    amin=100000; igood=1  # igood is a trap for all zero smooths or irrational growth smooths      
    
    for (i in 1:myrs) {
        if((i+yrf-1) >= dmin  &&  (i+yrf-1) <= dmax) {
            if((i+yrf-1) == 68) s1=lcnt[i]
            if((i+yrf-1) == 93) s2=lcnt[i]
            if(lcnt3[i] > -0.5) xsumyr=xsumyr+lcnt3[i]
            if(lcnt3[i] > -0.5) totyr=totyr+1.
            if(lcnt3[i] > 0) anonz=anonz+1.
            if(yrs2[i] < amin) amin=yrs2[i]      
            numfin=numfin+1
            if(lcnt[i] > 0.001) nonz=1  #       here is where the square rt is removed####
            if(lcnt[i] > 9999.0) igood=0
            if(lcnt[i] > 9999.0) lcnt[i]=9999.0
        }
    }
    amin=yrs2[1]+(yrf-1)
    
    if(nonz == 0) igood=0
    if((igood != 1) && (oof >= 0.75)) a10<<-c(a10,paste(aou, stanow,rtnow, 'bad route-omitted'))
    if(igood != 1) blues=-9999.0
    if((igood == 0) && (oof >= 0.75))  return(list(alt=alt, xsum=xsum, backm=backm, blues=blues))

    if((alt != 5) && (igood != 0)) 
        a8<<-c(a8,sprintf('%5d%5d%5d%3d%6d%5d%5d%5d%7.2f%7.2f%7.2f%7.2f',
            stanow,rtnow,strnow,numfin,totyr,xsumyr,anonz,amin, a1,a2,s1,s2)) 

    #  change these 42's to 8 29 july 1996
    if((alt != 5) && (igood != 0)) {
        a8x=sprintf('%5d%5d%5d',stanow,rtnow,strnow)
        for (i in 1:numfin) a8x=paste0(a8x,sprintf('%8.3f',lcnt[i]))
        a8<<-c(a8,a8x)
    }

    early=ne=late=nl=0  #    now calculate the "trend" and mean count                  
    for (i in 1:3) {
        ie=i+4; il=i+20
        if(lcnt[ie] >= 0) early=early+lcnt[ie]
        if(lcnt[ie] >= 0) ne=ne+1.0
        if(lcnt[il] >= 0) late=late+lcnt[il]
       if(lcnt[il] >= 0) nl=nl+1.0
    }
    if(ne > 0) early=early/ne
    if(nl > 0) late=late/nl
    if(early <= 0.000001) early=0.001
    if(late <= 0.000001) late=0.001
    blues=((late)/(early))^(1/16)
    backm=early*(blues^(8))
    if(alt == 5) return(list(alt=alt, xsum=xsum, backm=backm, blues=blues))

    prop=-1.0
    if(igood != 1) blues=9999.0  #   igood is the trap for nonconvergence
    return(list(alt=alt, xsum=xsum, backm=backm, blues=blues))
}