      SUBROUTINE INDELOIS(N,NCOL,RTNOW,STANOW,STRNOW,DES,CNT,AOU,YRF,YRL,blues,backm,sum,alt)

C    This is a semiparametric smooth ala the instructions  of Hasti and Timsurabi, as given in James et al (1995)
C    In this version,  "robust" Loess is not used.   No transform of data before analysis
C******NOTE THAT YRF AND YRL ARE PASSED

C  THIS SUBROUTINE PRINTS OUT THE DESIGN MATRIX AND COUNTS TO  AN OUTPUT FILE FOR THE INDEX ANALYSIS  JRS 22 MAY 1987.

      PARAMETER (MYRS=200,MCOLS=40)
      real*8 DES(MYRS,MCOLS), CNT(MYRS),prop,blues,backm,early,late,ne,nl,sum,XPR(MCOLS,MYRS),XPX(MCOLS,MCOLS),XPXINV(MCOLS,MCOLS),XPY(Mcols), BMAT(Mcols,1)
      real*8 lcnt(myrs),DES3(MYRS,MCOLS), LCNT2(MYRS),oof,FX(MYRS),FY(MYRS),YRS(MYRS),YRS2(MYRS),yrs3(myrs),g(MYRS,MCOLS),amax,an1,sumg(MYRS)
      real*8 max,min,lcnt3(myrs),cor1(myrs),cor2(myrs),a1,a2,cmin,s1,s2,sumyr,amin
      REAL RTNOW,STANOW,STRNOW, YRF,YRL
      INTEGER N,NNCOL,AOU,alt
      integer iobs(myrs)
      nn=n
      nncol=ncol
      if (ncol.gt.MCOLS) STOP('*********** ERROR: TOO MANY COLS (INDELOIS) ***')
      if ((YRL-YRF+1).GT.MYRS) STOP('****** ERROR: TOO MANY YEARS(INDELOIS) ***')

c  minimum data check (use the James criteria)

      oof=0.5d0 !  set tension parameter (oof) to 0.5

      call minwt(NN,NNCOL,DES,CNT,YRF,cmin)
      IF((cmin.lt.0.0d0).and.(alt.ne.5)) blues=-9998.0d0
      if(alt.eq.5)  then
         write(*,'(a/a/a)')'Time Series of Species Data','Year','Count'
      end if

C ROUTES THAT REACH HERE ARE OK
      
      do i=1,MYRS          !    SET UP 2 MATRICES WITH YEARS FROM 1 TO MYRS INTO LCNT,
         YRS2(I)=FLOAT(i)  !    PUT THE COUNTS (-1=MISSING) INTO IOBS, PUT THE OBSERVER NUMBER
         lcnt(i)=-1.       !    FIRST SET ALL COUNTS TO -1 AND ALL OBS TO BLANKS
         lcnt3(i)=-1.
         iobs(i)=0
         cor2(i)=0.0d0
         cor1(i)=0.0d0
      end do
      min=10000.0d0
      max=0.0d0
      nonzero=0
      sum=0.0d0
      a1=0.
      an1=0.
      a2=0.
      an2=0.    !  NOW GO THROUGH THE DATA FOR THE ROUTE AND PUT IT IN MATRICES

      do i=1,nn
         k=idint(des(i,2)-(YRF-1.))  !   FIND THE YEAR FOR THIS ONE (NOTE YEARS START AT YRF)
         iobs(k)=0                   !  ******************************************************
         sum=sum+(exp(cnt(i))-0.5)   !  lcnt and g have years missing in them ****************
         if(nncol.eq.2) iobs(k)=1    !  ******************************************************
         if(des(i,2).lt.min) min=des(i,2)
         if(des(i,2).gt.max) max=des(i,2)
         yrs2(i)=des(i,2)-(yrf-1.)
         lcnt(k)=exp(cnt(i))-0.5
         if((des(i,2).ge.66.).and.(des(i,2).le.70.1)) a1=a1+lcnt(k)
         if((des(i,2).ge.66.).and.(des(i,2).le.70.1)) an1=an1+1.0
         if((des(i,2).ge.91.).and.(des(i,2).le.95.1)) a2=a2+lcnt(k)
         if((des(i,2).ge.91.).and.(des(i,2).le.95.1)) an2=an2+1.0
         if(lcnt(k).gt.0.9d0) nonzero=nonzero+1
         lcnt3(k)=lcnt(k)  !    lcnt3 is a storage for the raw data for all years
         do j=1,nncol      !    put the data for year k into the matrix g
            g(k,j)=des(i,j)
         end do
         IF(NNCOL.ne.2) then
            do j=3,nncol
               if(des(i,j).ge. 1.0d0) iobs(k)=j-2
            end do
            if(iobs(k).eq.0) iobs(k)=nncol-1
         END IF
      end do
      if(an1.gt.0.0) a1=a1/an1
      if(an2.gt.0.0) a2=a2/an2
      sum=sum/float(nn)

C  NOW, DATA ARE IN THE MATRIX.  GET RID OF THE MISSING YEARS FOR INPUT TO THE LOESS

      NUMDAT=0
      DO I=1, MYRS
         IF(LCNT(I).GT.-1.0d0) THEN
            NUMDAT=NUMDAT+1
           LCNT2(NUMDAT)=LCNT(I)
            ifff=0
            do j=1,nncol
               if(j.eq.2) yrs3(numdat)=g(i,j)-(yrf-1.0d0)
               if(j.eq.1) des3(numdat,j)=g(i,j)
               if(j.gt.2) des3(numdat,j-1)=g(i,j)
               if(j.ge.3) then
                  if(des3(numdat,j-1).gt.0.0d0) ifff=1
               end if
            end do
            if(ifff.eq.1) des3(numdat,1)=0.0d0  !   here we set up the final observer, and replace the first row of ones with its data
         END IF
         LCNT(I)=-1.
      END DO

      if(alt.eq.5) iadd=int(max-min)+1

c *******here is the trap for minwt!!!!!!!!!!!

      IF(cmin.lt.0.0d0) RETURN

      if(nncol.le. 2) then   !    WE SHOULD NOW BE READY TO CALL LOIS
         do i=1,numdat
            cor1(i)=lcnt2(i)
            yrs(i)=yrs3(i)
         end do
      else

c  Now, the input files LCNT2 and DES3 contain the data, for numdat years  no missing data in it.

         g=0          !    now set g(i,j) =0.  fortran90 feature... set entire matrix to zero
         do i=1,nncol !    semiparametric stuff.
            amax=0.0d0
            do j=1,numdat     !             here are the 2 pieces of the smooth
               sumg(j)=des3(j,i)
               yrs(j)=yrs3(j)
               if(i.eq.nncol) sumg(j)=lcnt2(j)
               if(yrs(j).gt.amax) amax=yrs(j)  ! for the year column yrs is indexed to yrf=1
               lcnt(j)=0.0d0
            end do

            call loess(fx,fy,YRS,sumg,NUMDAT,LCNT,YRS2,yrf,yrl,oof)  !           now smooth sumg vs yrs(j)

c  now have to omit the years that are missing in yrs...  this includes missing intermediate yrs and beyond endpoints
c  smooth is done, now update g

             jj=1
             do j=1,numdat
c                write(*,*) 'after loess sumg,lcnt',j,sumg(j),lcnt(j)
                if(yrs2(j).ge.yrs(jj)) then  !  if yrs doesn't equal yrs2, skip it
                   g(jj,i)=lcnt(j)
                   if(i.eq.nncol) lcnt(jj)=lcnt(j)
                   jj=jj+1
                end if
             end do
             continue
             if(jj.eq.1) write(*,*) 'loes switch back did not work!'
         end do
c   *******  end of loop for each column of the X matrix *********

c        all columns are done- check if converged
c        calculate the adjusted smooth (without missing years)
c        now, find xres and yres

         do i=1,numdat
            lcnt(i)=lcnt2(i)-lcnt(i)
            do j=1,nncol       
               if(j.lt.nncol) g(i,j)=des3(i,j)-g(i,j)
            end do
         end do

c        now, g and lcnt and the yres and Xres matrices    now find betahat= (X'Xres)-1 (X'Yres)
        print *,'des3'
        do i=1,numdat
           write(*,'(50f3.0)')(des3(i,j),j=1,nncol-1)
        end do
        print *,'g'
        do i=1,numdat
           write(*,'(10f8.3)')(g(i,j),j=1,nncol-1)
        end do
         CALL TRANS(Numdat,NNCOL-1,DES3,XPR)                              !  FIND THE X PRIME MATRIX XPRC
         print *,'xpr'
        do i=1,nncol-1
           write(*,'(50f3.0)')(xpr(i,j),j=1,numdat)
        end do
        CALL MATMLT(XPR,g,XPX,NNCOL-1,Numdat,NNCOL-1,MCOLS,MYRS,MCOLS)   !  FIND THE X PRIME-X MATRIX
        print *,'xpx'
        do i=1,nncol-1
           write(*,'(10f8.2)')(xpx(i,j),j=1,nncol-1)
        end do
        if((xpx(1,1).le.-9998.0d0).and.(oof.ge.0.75d0)) write(7,*) aou, stanow, rtnow,'second malmlt fail x-x'
         if((xpx(1,1).le.-9998.0d0).and.(oof.ge.0.75d0)) return

         CALL genINV(NNCOL-1,XPX,XPXINV)                              !  FIND THE X PRIME X INVERSE MATRIX
        print *,'xpxinv'
        do i=1,nncol-1
           write(*,'(10f8.2)')(xpxinv(i,j),j=1,nncol-1)
        end do
        
        CALL MATMLT(XPR,lCNT,XPY,NNCOL-1,Numdat,1,MCOLS,MYRS,1)      !  FIND THE X PRIME Y VECTOR
        print *,'xpy'

           write(*,'(10f8.2)')(xpy(j),j=1,1)

        
        if((xpy(1).le.-9998.0d0).and.(oof.ge.0.75d0)) write(7,*) aou, stanow, rtnow,'second malmlt fail-x-y'
         CALL MATMLT(XPXINV,XPY,BMAT,NNCOL-1,NNCOL-1,1,MCOLS,MCOLS,1)  ! FIND THE B VECTOR (X'X)-1 (X'Y)
        print *,'bmat'

           write(*,'(10f8.2)')(bmat(j,1),j=1,nncol-1)

         if((bmat(1,1).le.-9998.0d0).and.(oof.ge.0.75d0)) write(7,*) aou, stanow, rtnow,' second malmlt fail at b'

c        so bmat is the beta for the smoothed variables. find Y-X*bmat

         CALL MATMLT(des3,bmat,cor2,numdat,NNCOL-1,1,Myrs,Mcols,1)     ! FIND THE X bmat VECTOR, call it xpy for now
         if((cor2(1).le.-9998.0d0).and.(oof.ge.0.75d0)) write(7,*) aou, stanow, rtnow,'second malmlt fail-x-b'
         if((cor2(1).le.-9998.0d0).and.(oof.ge.0.75d0)) return

         do j=1,numdat
            cor1(j)=lcnt2(j)-cor2(j)
            yrs(j)=yrs3(j)
            lcnt(j)=-1.0d0
         end do
c        **** end of semiparametric loop ***********************
      end if

c  now do a final loess on the data.  here, redefine yrs2 to be from min to max
      do i=1,nn+iadd
         yrs2(i)=(min-yrf+1.0d0)+(float(i)-1.0d0)
      end do

      call loess(fx,fy,YRS,cor1,NUMDAT,LCNT,YRS2,yrf,yrl,oof)

      if(alt.eq.5) then
         do i=1,iadd
            write(*,'(f7.2,1x,f12.4)') yrs2(i)+yrf-1.0d0,lcnt(i)
         end do 

         if(lcnt(1+2).le.0.0d0) lcnt(iadd-2)=lcnt(iadd-2)+0.1  !     these 1+2, iadd -2 are indexes for the "endpoints"  
         if(lcnt(1+2).le.0.0d0) lcnt(1+2)=0.1
         if(lcnt(iadd-2).le.0.0d0) lcnt(1+2)=lcnt(1+2)+0.1
         if(lcnt(iadd-2).le.0.0d0) lcnt(iadd-2)=0.1
         blues=(((lcnt(iadd-2)/lcnt(1+2))**(1/(yrs2(iadd-2)-yrs2(1+2))))-1.0d0)*100.0d0

         write(*,340) blues, yrs2(1+2)+yrf-1.0d0, yrs2(iadd-2)+yrf-1.0
  340    format('<P>LOESS:  ',f6.2,3x,' (over interval ',f5.0,' to ',f5.0,')')  
      end if
      numfin=0


      igood=1  !    igood is a trap for all zero smooths or irrational growth smooths
      nonz=0
      atot=0.0
      sumyr=0.
      anonz=0.
      totyr=0.      
      amin=100000.       
      s1=0.
      s2=0.
      do i=1,myrs
         if((float(i)+(yrf-1.)).ge.min .and. (float(i)+(yrf-1.)).le.max) then
            if((float(i)+(yrf-1.)).eq.68.) s1=lcnt(i)
            if((float(i)+(yrf-1.)).eq.93.) s2=lcnt(i)
            if(lcnt3(i).gt.-0.5) sumyr=sumyr+lcnt3(i)
            if(lcnt3(i).gt.-0.5) totyr=totyr+1.
            if(lcnt3(i).gt.0.0) anonz=anonz+1.
            if(yrs2(i).lt.amin) amin=yrs2(i)      
            numfin=numfin+1
            if(lcnt(i).gt.0.001d0) nonz=1  !       Here is where the square rt is removed!!!!
            if(lcnt(i).gt.9999.0d0) igood=0
            if(lcnt(i).gt.9999.0d0) lcnt(i)=9999.0d0
         end if
      end do
      amin=yrs2(1)+(yrf-1.)
     
      if(nonz.eq.0) igood=0
      if((igood.ne.1).and.(oof.ge.0.75d0)) write(10,*) aou, stanow,rtnow, 'bad route-omitted'
      if(igood.ne.1) blues=-9999.0d0
      if((igood.eq.0).and.(oof.ge.0.75))  go to 999

      if((alt.ne.5).and.(igood.ne.0)) write(8,83) stanow,rtnow,strnow,numfin,totyr,sumyr,anonz,amin, a1,a2,s1,s2
   83 format(3f5.0,i3,1x,4f5.0,4(1x,f6.2))   

c  change these 42's to 8 29 July 1996
      if((alt.ne.5).and.(igood.ne.0)) write(8,80) stanow,rtnow,strnow,(lcnt(I),I=1,numfin)
   80 format(3f5.0,50(F8.3))

      early=0.0d0  !    now calculate the "trend" and mean count
      ne=0.0d0
      late=0.0d0                  
      nl=0.0d0                  
      do i=1,3
         ie=i+4   
         il=i+20
         if(lcnt(ie).ge.0.0d0) early=early+lcnt(ie)
         if(lcnt(ie).ge.0.0d0) ne=ne+1.0d0
         if(lcnt(il).ge.0.0d0) late=late+lcnt(il)
         if(lcnt(il).ge.0.0d0) nl=nl+1.0d0
      end do
      if(ne.gt.0.0d0) early=early/ne
      if(nl.gt.0.0d0) late=late/nl
      if(early.le.0.000001d0) early=0.001d0
      if(late.le.0.000001d0) late=0.001d0
      blues=((late)/(early))**(1.0d0/16.0d0)
      backm=early*(blues**(8.0d0))
      if(alt.eq.5) return

      prop=-1.0d0
      if(igood.ne.1) blues=9999.0d0  !   igood is the trap for nonconvergence
  999 RETURN
      END





