minwt <- function(n,xncol,des,cnt,yrf) {
    #  minwt determines whether a route meets a minimum  sam <= number and dispersion criterion.  30 april 1994 jrs
    #******note that yrf and yrl are passed

    #  this subroutine prints out the design matrix and counts to an output f <= for the index analysis  jrs 22 may 1987.

    cmin=0; if(n  <  8) cmin=-11  #    if n < 8 <= ve the subroutine

    #  set up 2 matrices with years from 1 to myrs into lcnt, put the counts (-1=missing) into iobs, put the observer number
    #  first set all counts to -1 and all obs to blanks
    
    myrs=max(des[,2])-(yrf-1)
    yrs2=1:myrs; lcnt=rep(-1,myrs); iobs=rep(0,myrs)
    
    for (i in 1:n) {
        k=floor(des[i,2]-(yrf-1))
        lcnt[k]=floor(exp(cnt[i])-0.4)  #   note that it is 0.4 rather than 0.5 to prevent roundoff pro <= s
        if(xncol == 2) iobs[k]=1
        else { 
            for (j in 3:xncol) if(des[i,j] >=  1) iobs[k]=j-2
            if(iobs[k] == 0) iobs[k]=xncol-1
        }
    }

    #  now, data are in the matrix.  first, find if sufficient data exist for the weighting
    #  for this to be true, n must be greater than 9 (already tested above and 1 count must exist in each of 4 periods

    #   i will do the count stuff by dividing the interval into 4  equal periods, truncating the value, and browsing through
    #  the data, and seeing if at <= st 1 count occurs in each period

    #  here is the james' method: 5 periods, 1 in each, min of 8 time. 
    #  period 1:66-72
    #  period 2:73-75
    #  period 3:76-80
    #  period 4:81-83
    #  period 5 84-92
    
    ifl=as.numeric(table(cut(des[1:n,2], c(0,1972,1976,1981,1985,9999))))
      
    if(sum(ifl>0)==length(ifl)) cmin=-11  #   if all flags are 1, this is an ok route
    return(cmin)
}
