      SUBROUTINE minwt(N,NCOL,DES,CNT,YRF,cmin)
C  Subroutine minwt determines whether a route meets a minimum  sample number and dispersion criterion.  30 April 1994 jrs
C******NOTE THAT YRF AND YRL ARE PASSED

C  THIS SUBROUTINE PRINTS OUT THE DESIGN MATRIX AND COUNTS TO AN OUTPUT FILE FOR THE INDEX ANALYSIS  JRS 22 MAY 1987.

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS), CNT(MYRS),cmin
      REAL YRF
      INTEGER N,NCOL,IFL(5)
      double precision lcnt(myrs),YRS2(MYRS)
      integer iobs(myrs)
      cmin=0.0d0
      print *,'minwt: des='
      do i=1,6
        print *,(des(i,j),j=1,6)
      end do
      
      IF(n .LT. 8) cmin=-11.0d0  !    IF N < 8 LEAVE THE SUBROUTINE

C  SET UP 2 MATRICES WITH YEARS FROM 1 TO MYRS INTO LCNT, PUT THE COUNTS (-1=MISSING) INTO IOBS, PUT THE OBSERVER NUMBER
C  FIRST SET ALL COUNTS TO -1 AND ALL OBS TO BLANKS

      do i=1,myrs
         YRS2(I)=FLOAT(i)
         lcnt(i)=-1
         iobs(i)=0
      end do
      do i=1,n
         k=idint(des(i,2)-(YRF-1.))
         lcnt(k)=idint(exp(cnt(i))-0.4)  !   note that it is 0.4 rather than 0.5 to prevent roundoff problems
         if(ncol.eq.2) iobs(k)=1
         IF(NCOL.ne.2) then
            do j=3,ncol
               if(des(i,j).ge. 1.0d0) iobs(k)=j-2
            end do
            if(iobs(k).eq.0) iobs(k)=ncol-1
         end if
      end do

C  NOW, DATA ARE IN THE MATRIX.  FIRST, FIND IF SUFFICIENT DATA EXIST FOR THE weighting
C  FOR THIS TO BE TRUE, N MUST BE GREATER THAN 9 (ALREADY TESTED ABOVE AND 1 COUNT MUST EXIST IN EACH OF 4 PERIODS

C   I WILL DO THE COUNT STUFF BY DIVIDING THE INTERVAL INTO 4  EQUAL PERIODS, TRUNCATING THE VALUE, AND BROWSING THROUGH
C  THE DATA, AND SEEING IF AT LEAST 1 COUNT OCCURS IN EACH PERIOD

c  here is the James' method: 5 periods, 1 in each, min of 8 time. 
c  here is period 1: 66-72
c  period 2:73-75
c period 3:76-880
c period 4: 81-83
c period 5 84-92
      do i=1,5
         ifl(i)=0
      end do
      do i=1,n
         if(des(i,2).LE.1972.1d0) THEN
            ifl(1)=1
         ELSE if(des(i,2).LE.1976.1d0) THEN
            ifl(2)=1
         ELSE if(des(i,2).LE.1981.1d0) THEN
            ifl(3)=1
         ELSE if(des(i,2).LE.1985.1d0) THEN
            ifl(4)=1
         ELSE
            ifl(5)=1
         END IF
      end do
      IALLF=1  !   IF ALL FLAGS ARE 1, THIS IS AN OK ROUTE
      DO I=1,5
         IF(IFL(I).EQ. 0) IALLF=0
      END DO
      IF(IALLF.EQ. 0) cmin=-11.0d0
      return
      end
