      SUBROUTINE PROPS(N,M,AINC,ADEC,SIGGY)

C  THIS SUBROUTINE READS THE N(I,3) AND N(I,4) DATA, CALCULATES THE PROPORTION OF INCREASING (OR DECREASING ROU) ROUTES,
C  THEN FINDS THE SIGNIFICANCE OF THE VALUE (2-SIDED)

      INTEGER N(280,4),M
      REAL ZVAL
      CHARACTER*4 SIGGY



      AINC=0.0   !   FIRST FIND THE OVERALL PROPORTION OF INCREASERS AND DECREASERS IN THE STATE OR STRATUM)
      ADEC=0.0
      ATOT=0.0
      DO I=1,M
        AINC=AINC+(FLOAT(N(I,3)))
        ADEC=ADEC+FLOAT(N(I,4))
        ATOT=ATOT+(FLOAT(N(I,1)))
      END DO
      SIGGY='    '
      IF(ATOT.EQ.0.0) RETURN
      AINC=AINC/ATOT
      ADEC=ADEC/ATOT
      VARINC=AINC*(1.0-AINC)/ATOT
      VARDEC=ADEC*(1.0-ADEC)/ATOT

C  NOW DO THE Z-TEST TO DETERMINE IF THE PROPORTION OF INCREASERS IS THE SAME AS THE PROP OF DECREASERS

      IF((AINC.EQ.0.0).OR.(ADEC.EQ.0.0)) RETURN
      ZVAL=(ADEC-0.5)/(SQRT((ADEC*AINC)/ATOT))

C  THIS TESTS THE HYPOTHESIS THAT ADEC-0.5=0
C  IF ZVAL IS NEG AND SIG, THEN ADEC>AINC, AND THE POP IS DEC
C  IF ZVAL IS POS , THEN AINC>ADEC, AND THE POP IS INC.

      IF(ABS(ZVAL).GT. 1.64) SIGGY='   *'
      IF(ABS(ZVAL).GT. 1.96) SIGGY='  **'
      IF(ABS(ZVAL).GT. 2.47) SIGGY=' ***'
      RETURN
      END
