settwo <- function(n,nobs,des,beta,covar,cnt,wtxpx,obs) {

#  this subroutine takes care of routes with n=2, using point=intercept 
# to calculate the line

    n1=1;  n2=2; beta=covar=msedf=margm=varmar=0
    if(n != 2) {
       n1=n2=0  #   reset n1 and n2 for the analysis

       #  check through the observer vector for the two observers. 
       #  if not found, check to see if the last 2 values of obs are the same
       i=1
       while(n2 <= 0 && i <=  n)
          n1=n2=0
          for (j in (i+1):n) {
            if(obs(i)  ==  obs(j)) {
              n1=i; n2=j
            }
          }
          i=i+1
       }
       #  now if the n1 and n2 aren't found, check the last 2 observers
       if(n2  <=  0 && obs(n-1) ==  obs(n)) { n1=n-1;  n2=n }
       if(n2  <=  0) {   #    to reach here, you either messed up (i>n) or you know n1 and n2.
          a7=c(a7,paste('attempt to find 2 pt slope failed, n=',n,', nobs=',nobs))
          beta=-99.00
          return(list(beta=beta, covar=covar, msedf=msedf, margm=margm, varmar=varmar, wtxpx=wtxpx))
       }
    }
    if(des(n2,2) == des(n1,2)) {  #  if 2 in same year, set slope, varmar,margm=0,return
       beta=margm=varmar=0
       return(list(beta=beta, covar=covar, msedf=msedf, margm=margm, varmar=varmar, wtxpx=wtxpx))
    }
    beta=(cnt[n2]-cnt[n1])/(des[n2,2]-des[n1,2])
    covar=wtxpx=2; msedf=1; margm=(cnt[n2]+cnt[n1])/2
    varmar=1
    return(list(beta=beta, covar=covar, msedf=msedf, margm=margm, varmar=varmar, wtxpx=wtxpx))
}
