      SUBROUTINE SETTWO(N,NOBS,DES,BETA,COVAR,MSEDF,MARGM,VARMAR,CNT,WTXPX,OBS)

C  THIS SUBROUTINE TAKES CARE OF ROUTES WITH N=2, USING POINT=INTERCEPT TO CALCULATE THE LINE

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS),CNT(MYRS),BETA,COVAR,MARGM,VARMAR,WTXPX
      CHARACTER*5 OBS(MYRS)
      N1=1
      N2=2
      IF(N.ne.2) THEN
         N1=0  !   RESET N1 AND N2 FOR THE ANALYSIS
         N2=0

C  CHECK THROUGH THE OBSERVER VECTOR FOR THE TWO OBSERVERS. IF NOT FOUND, CHECK TO SEE IF THE LAST 2 VALUES OF OBS ARE THE SAME

         I=1
         DO WHILE(N2.LE.0 .AND. I.LE. N)
            N1=0
            N2=0
            DO J=(I+1),N
              IF(OBS(I) .EQ. OBS(J)) THEN
                N1=I
                N2=J
              ENDIF
            END DO
            I=I+1
         END DO

C  NOW IF THE N1 AND N2 AREN'T FOUND, CHECK THE LAST 2 OBSERVERS

         IF(N2 .LE. 0 .AND. OBS(N-1).EQ. OBS(N)) THEN
            N1=N-1
            N2=N
         END IF

         IF(N2 .LE. 0) THEN   !    TO REACH HERE, YOU EITHER MESSED UP (I>N) OR YOU KNOW N1 AND N2.
            WRITE(7,50) N, NOBS
   50       FORMAT(' ATTEMPT TO FIND 2 PT SLOPE FAILED, N, NOBS=',2I5)
            BETA=-99.00
            RETURN
         END IF
      END IF
   
      IF(DES(N2,2).EQ.DES(N1,2)) THEN  !  IF 2 IN SAME YEAR, SET SLOPE, VARMAR,MARGM=0,RETURN
         BETA=0.0
         MARGM=0.0
         VARMAR=0.0
         RETURN
      END IF

      BETA=(CNT(N2)-CNT(N1))/(DES(N2,2)-DES(N1,2))
      COVAR=2.0
      WTXPX=2.0
      MSEDF=1
      MARGM=(CNT(N2)+CNT(N1))/2.0
      VARMAR=1.0
      RETURN
      END
