slope <- function(isuper,linear,ndist,noco,yrf,yrl,midyr, sta,rt,obsin,str,yr,itype,aou,hrd,mflag,noslopes,alt,alt2,yr1) {

#   this trend analysis program reads in data for each route,  calculates a linear estimate of trend on ln(count+0.5)
#   with observer as a covariable, then prints out the estimate  of the trend along with accessory data for each route.   john sauer, ombm, 22 april 1986
#      parameter (myrs=200,mcols=40)
#      double precision des(myrs,mcols), cnt(myrs), bmat(myrs), cova(mcols,mcols),bluesm,wtm,blink,varmar, margm, wtxpx,backm,blues, dist(myrs),cmax,cmin,sum,blvar
#      integer alt, n,nobs,xncol,iflag,i,alt2,  itype,aou,aouin,mflag
#      character*5 obs(myrs), obsin                                         #  variables with the suffix 'now' represent the current route.
#      real sta, stanow, yr,rt,str,hrd,ang,yr1, rtnow,strnow,midyr    #   the others are from the route most recently read in.  
   # remember to reset the route
   
   missing <- function(yr,yrf,yrl,sta,rt,alt,isuper) { #   add missing value codes for missing disturbance -
      iflag=0
      if(yr  ==  0) iflag=1
      if(yr < yrf) iflag=1
      if(yr > yrl) iflag=1
      if(sta  ==  0) iflag=1
      if(rt  ==  0) iflag=1
      if(alt == 0) return(iflag)
      if((isuper ==  1) && (rt >= 800)) iflag=1
      return(iflag)
   }
   
   sub1000 <- function() {  #  1000 continue
      #  now analyze the last group.  now xcall=in superdeck: it will add in zero routes.
      
      if(alt != 9) xcall=super(rtnow,stanow,n,nobs,des,cnt,obs,strnow,noco,yrf,yrl,isuper)
      
      #  check for all zero routes
      
      xcall=allzero(stanow,rtnow,n,nobs,cnt,iflag,linear,ndist, strnow,alt)
      if(iflag  ==  1) return
      
      if(((iflag == 3) && (linear == 3)) || (linear == 2)) {
         xcall=setcolmn(nobs,n,xncol,des,obs); des=xcall$des; xncol=xcall$xncol; obs=xcall$obs
      }
      if(iflag  ==  3) iflag=2
      skip750=0; if(iflag  ==  2) skip750=1 # go to 750
      
      #  call the analysis
      
      if(linear != 2) { 
         if (skip750==0) {
            xcall=analy(nobs,n,xncol,des,obs,cnt,bmat,cova,margm,varmar, wtxpx)
            bmat=xcall$bmat; cova=xcall$cova; margm=xcall$margm; varmar=xcall$varmar; wtxpx=xcall$wtxpx
            des=xcall$des; obs=xcall$obs
            msedf=n-xncol            #   call the back-transformation subroutine for the slope
            if(linear != 1) xcall=paultran(msedf,bmat[2],cova[2,2],blues)
         }
         #750 
         if(iflag  ==  2) xcall=settwo(n,nobs,des,bmat[2],cova[2,2], msedf,margm,varmar,cnt,wtxpx,obs)
         if(linear  ==  1) blues=bmat[2]
         if((iflag == 2) && (linear != 1)) blues=exp(bmat[2])
         
         #            now call the subroutine to back transform the marginal mean.
         xcall=gmneed(midyr,n,des,margm,varmar,cnt,iflag,msedf,cmax,cmin,xsum)
         if((linear !=  1) && (iflag != 2)) xcall=paultran(msedf,margm,varmar,backm)
         if(linear  ==  1) backm=margm
         if(iflag  ==  2) backm=exp(margm)
         if(linear  !=  1) backm=backm-0.5
         
         #  roundoff error could make the back-transformed mmean < 0,  so if negative, make it a small positive  if 2 years, let it be 0
         if((backm <= 0.0) && (iflag != 2)) backm=0.001 
         if((blues > 0.0) || (backm > 0.0) || (wtxpx > 0.0)) noslopes=1
         malt=1
      }
      if((linear ==  2) || (alt == 5)) { #   here is the lowess subroutine
         xcall=indelois(n,xncol,rtnow,stanow,strnow,des,cnt,aouin,yrf,yrl,blues,backm,xsum,alt) 
         alt=xcall$alt; xsum=xcall$xsum; backm=xcall$backm; blues=xcall$blues
      }
      if(blues > -9990) { 
         myr=floor(min(des[,2])); msedf=n-xncol
         
         #    here is a version that prints out a variance       jrs 11 may 1994.   this is a variance based on the bradu-mundlac stuff
         
         wtm=(blues/exp(bmat[2]))*exp(2.0*bmat[2])*cova[2,2]*10000.0
         ast=stanow*1000+rtnow
         bluesm=(blues-1.0)*100.0
         
         if(imnwt ==  2) cmin=minwt(n,xncol,des,cnt,yrf)
         iflag=0                #   here is the call the the estimating equation approach 15 june 1994
         if(linear == 3) {
            xcall=calclink(stanow,rtnow,n,xncol,des,cnt,yrf,blues)
            blues=xcall$blink
            cova[2,2]=xcall$var
            xcall=cutxpx(n,xncol,des,wtxpx,cnt)
         }
         #         if iflag = 0, skip writert
         if(!(linear == 2 || ((linear == 3) && (iflag == 0)))) 
            xcall=writert(rtnow,stanow,strnow,cova,ang,blues, varmar,backm,wtxpx,cmax,cmin,xsum,n,aouin,alt)
      }
      return(0)
   } # end function sub1000
   
#  imnwt is a temporary flag to allow check of minimum sample wts. 2 means that min sample wt is checked
imnwt=0; myrs=200; mcols=40

#  set up the first column to be ones
des=matrix(0,myrs,mcols); des[,1]=1

#  if first time through, skip first read (use values from main program)
#  put these in here so that if 1 route exists for  the spp and it has an improper type, the program doesn't bomb

n=0;nobs=1;aouin=aou;rtnow=rt;stanow=sta; if(isuper != 1) strnow=str
skip44=0; if(alt != 2) skip44=1 # go to 44
iflag=1; ii=0

while (iflag == 1) {   #30 continue
	#  commented in dec 2005 for alaska analysis#      iend=0
	if (skip44==0) {
		if((alt == 2) || (alt >= 4)) {
		   xcall=readdats(alt,stanow,rtnow,strnow,itype,n,xncol,des,yrf,yrl,noco,alt2,yr1)
		   iend=xcall$iend; n=xcall$n; xncol=xcall$xncol; nobs=xcall$nobs; obs=xcall$obs; cnt=xcall$cnt; des=xcall$des
		}
	   
		if(iend == 1) { mflag=1; iend=0; return(0)}
		skip543=0; 
		if((alt == 2) || (alt >= 4)) { skip543=1; break}  
		else { # go to 543
			#  if new species, analyze last route, then exit
			if(aou  !=  aouin) { sub1000(); return(0)}
		}
	}
  # 44 
	# if no covariable, set observer=nun
	iflag=missing(yr,yrf,yrl,sta,rt,alt,isuper)
	skip44=0; i=ii+1
}   #  go to 30

if (skip543==0) {
   n=0; nobs=1  #  no missing data, so store it in data arrays
   xcall=setdata(n,yr,obsin,hrd,obs,des,cnt,linear,dst,dist,ndist,isuper)
   n=xcall$n; obs=xcall$obs; des=xcall$des; cnt=xcall$cnt; dist=xcall$dist
   rtnow=rt; stanow=sta; if(isuper != 1) strnow=str
}
while (1) { #  50 continue
   
	if (skip543==0) {
		if((alt == 2) || (alt >= 4)) {
		   xcall=readdats(alt,stanow,rtnow,strnow,itype,n,xncol,des,yrf,yrl,noco,alt2,yr1)
		   iend=xcall$iend; n=xcall$n; xncol=xcall$xncol; nobs=xcall$nobs; obs=xcall$obs; cnt=xcall$cnt; des=xcall$des
		}
		if(iend == 1) { mflag=1; iend=0; return(0)}
		if((alt != 2) && (alt < 4)) { # go to 543
			if(aou  !=  aouin) { sub1000(); return(0)}  #  go to 1000
			iflag=0

			#   if no observer covariable set observer to nun
			iflag=missing(yr,yrf,yrl,sta,rt,alt,isuper)
			if(iflag  ==  1) next
			if(rt == rtnow && sta == stanow) {
				xcall=setdata(n,yr,obsin,hrd,obs,des,cnt,linear,dst,dist,ndist,isuper)
				n=xcall$n; obs=xcall$obs; des=xcall$des; cnt=xcall$cnt; dist=xcall$dist
				next
			}
			#500 continue
			#  now here is the analysis,  now call in superdeck: it will add in zero routes.
			if(alt != 9) xcall=super(rtnow,stanow,n,nobs,des,cnt,obs,strnow,noco,yrf,yrl,isuper)
		}
	}
   skip543=0
	#  check for all zero routes
	#543 continue
	xcall=allzero(stanow,rtnow,n,nobs,cnt,iflag,linear,ndist, strnow,alt)
	iflag=xcall$iflag; nobs=xcall$nobs
	if(iflag  ==  1) { #go to 600
		rtnow=rt; stanow=sta; n=0; nobs=1; if(isuper != 1) strnow=str
		xcall=setdata(n,yr,obsin,hrd,obs,des,cnt,linear,dst,dist,ndist,isuper)
		n=xcall$n; obs=xcall$obs; des=xcall$des; cnt=xcall$cnt; dist=xcall$dist
		next
	}
	
	#  call the analysis. dont let the routes with n=2 go in to analy
	if(((iflag == 3) && (linear == 3)) || (linear == 2)) {
	   xcall=setcolmn(nobs,n,xncol,des,obs); des=xcall$des; xncol=xcall$xncol; obs=xcall$obs 
	}

	if(iflag == 3) iflag=2
	skip550=0; if(iflag  ==  2) skip550=1 # go to 550
	if(linear != 2) { # go to 620
		if (skip550==0) {
		   xcall=analy(nobs,n,xncol,des,obs,cnt)
		   bmat=xcall$bmat; cova=xcall$cova; margm=xcall$margm; varmar=xcall$varmar; wtxpx=xcall$wtxpx
		   des=xcall$des; obs=xcall$obs
			#   call the back-transformation subroutine for the slope
		   
		   msedf=n-xncol
			if(linear != 1) blues=paultran(msedf,bmat[2],cova[2,2])
		}
		#550 
		if(iflag  ==  2) {
		   xcall=settwo(n,nobs,des,bmat[2],cova[2,2], cnt,wtxpx,obs)
		   bmat[2]=xcall$beta; cova[2,2]=xcall$covar; msedf=xcall$msedf;
		   varmar=xcall$varmar; margm=xcall$margm; wtxpx=xcall$wtxpx
		}		 
	   
		if(linear ==  1) blues=bmat[2]
		if((iflag == 2) && (linear != 1)) blues=exp(bmat[2])
		xcall=gmneed(midyr,n,des,margm,varmar,cnt,iflag,msedf)  #   now call the subroutine to back transform the marginal mean.
		margm=xcall$margm; varmar=xcall$varmar; msedf=xcall$msedf; cmin=xcall$cmin; cmax=xcall$cmax; xsum=xcall$xsum
		#  i have left the df=n-xncol regardless of which mean is used#
		
		if((linear != 1) && (iflag != 2))  backm=paultran(msedf,margm,varmar)
		if(linear  ==  1) backm=margm
		if(iflag  ==  2) backm=exp(margm)
		if(linear  !=  1) backm=backm-0.5
		if((backm <= 0.0) && (iflag != 2)) backm=0.001  #  roundoff error could make the back-transformed mmean < 0,  so if it is negative, make it a small positive value.

		if((blues > 0.0) || (backm > 0.0) || (wtxpx > 0.0)) noslopes=1  #  if slope  exists, set noslopes to 1
		malt=1
	}
	#620 
	
	if((linear ==  2) || (alt == 5)) {  #   here is the lowess subroutine
	   xcall=indelois(n,xncol,rtnow,stanow,strnow,des,cnt,aouin,yrf,yrl,blues,backm,xsum,alt)
	   alt=xcall$alt; xsum=xcall$xsum; backm=xcall$backm; blues=xcall$blues
	}
	if(blues > -9990) { #go to 345
		myr=floor(min(des[,2])); msedf=n-xncol
		#    here is a version that prints out a variance      jrs 11 may 1994.   this is a variance based on the bradu-mundlac stuff

		wtm=(blues/exp(bmat[2]))*exp(2*bmat[2])*cova[2,2]*10000
		#  this doesn't work for routes with only 1 nonzero count or with 2-year trends.  do not print these

		ast=stanow*1000+rtnow; bluesm=(blues-1.0)*100.0
		if(imnwt ==  2) cmin=minwt(n,xncol,des,cnt,yrf,cmin)

		iflag=0  #   here is the call the the estimating equation approach 15 june 1994
		if(linear == 3) {
		   xcall=calclink(stanow,rtnow,n,xncol,des,cnt,yrf,blues)
		   iflag=xcall$iflag; blues=xcall$b; blvar=xcall$var
		   blues=xcall$blink
		   xcall=cutxpx(n,xncol,des,wtxpx,cnt)
		   cova[2,2]=blvar
		}
		strnow=0
		if(!(linear==2 || (linear == 3 && (iflag == 0)))) 
		   xcall=writert(rtnow,stanow,strnow,cova,blues, varmar,backm,wtxpx,cmax,cmin,xsum,n,aou,alt)
	}
	rtnow=rt; stanow=sta; n=0; nobs=1; if(isuper != 1) strnow=str
	xcall=setdata(n,yr,obsin,hrd,obs,des,cnt,linear,dst,dist,ndist,isuper)
	
}  #  end while(1) loop

}  # end function slope
