      SUBROUTINE SLOPE(ISUPER,LINEAR,NDIST,NOCO,YRF,YRL,MIDYR, STA,RT,OBSIN,STR,YR,ITYPE,AOU,HRD,MFLAG,NOSLOPES,ALT,ALT2,yr1)

C   THIS TREND ANALYSIS PROGRAM READS IN DATA FOR EACH ROUTE,  CALCULATES A LINEAR ESTIMATE OF TREND ON LN(COUNT+0.5)
C   WITH OBSERVER AS A COVARIABLE, THEN PRINTS OUT THE ESTIMATE  OF THE TREND ALONG WITH ACCESSORY DATA FOR EACH ROUTE.   JOHN SAUER, OMBM, 22 APRIL 1986

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS), CNT(MYRS), BMAT(MYRS), COVA(MCOLS,MCOLS),bluesm,wtm,blink,VARMAR, MARGM, WTXPX,BACKM,BLUES, DIST(MYRS),CMAX,CMIN,SUM,blvar
      INTEGER ALT, N,NOBS,NCOL,IFLAG,I,ALT2,  ITYPE,AOU,AOUIN,MFLAG
      CHARACTER*5 OBS(MYRS), OBSIN                                         !  VARIABLES WITH THE SUFFIX 'NOW' REPRESENT THE CURRENT ROUTE.
      REAL STA, STANOW, YR,RT,STR,HRD,ANG,yr1, RTNOW,STRNOW,MIDYR    !   THE OTHERS ARE FROM THE ROUTE MOST RECENTLY READ IN.  

c  imnwt is a temporary flag to allow check of minimum sample wts. 2 means that min sample wt is checked
      imnwt=0


      DO I=1,myrs  !  SET UP THE FIRST COLUMN TO BE ONES
        DES(I,1)=1.0
      END DO

C  IF FIRST TIME THROUGH, SKIP FIRST READ (USE VALUES FROM MAIN PROGRAM)
C  PUT THESE IN HERE SO THAT IF 1 ROUTE EXISTS FOR  THE SPP AND IT HAS AN IMPROPER TYPE, THE PROGRAM DOESN'T BOMB

      N=0
      NOBS=1
      AOUIN=AOU
      RTNOW=RT
      STANOW=STA
      IF(isuper.ne.1) STRNOW=STR
      if(alt.eq.2) go to 30
      GO TO 44
   30 CONTINUE
c  commented in dec 2005 for alaska analysis
c      IEND=0
      if((alt.eq.2).or.(alt.ge.4)) call READDATs(ALT,STAnow,RTnow,STRnow,ITYPE,IEND,N,NCOL,DES,CNT,yrf,yrl,obs,nobs,noco,alt2,yr1)
      IF(IEND.EQ.1) GO TO 1100
      if((alt.eq.2).or.(alt.ge.4)) go to 543

C  IF NEW SPECIES, ANALYZE LAST ROUTE, THEN EXIT

      IF(AOU .NE. AOUIN) GO TO 1000
   44 IFLAG=0

C IF NO COVARIABLE, SET OBSERVER=NUN

      CALL MISSING(YR,YRF,YRL,STA,RT,HRD,IFLAG,ALT,isuper)
      IF(IFLAG .EQ. 1) GO TO 30



      N=0  !  NO MISSING DATA, SO STORE IT IN DATA ARRAYS
      NOBS=1
      CALL SETDATA(N,YR,OBSIN,HRD,OBS,DES,CNT,LINEAR,DST,DIST,NDIST,isuper)
      RTNOW=RT
      STANOW=STA
      IF(isuper.ne.1) STRNOW=STR

   50 CONTINUE

      if((alt.eq.2).or.(alt.ge.4)) call READDATs(ALT,STAnow,RTnow,STRnow,ITYPE,IEND,N,NCOL,DES,CNT,yrf,yrl,obs,nobs,noco,alt2,yr1)
      IF(IEND.EQ.1) GO TO 1100
      if((alt.eq.2).or.(alt.ge.4)) go to 543
      IF(AOU .NE. AOUIN) GO TO 1000
      IFLAG=0

C   IF NO OBSERVER COVARIABLE SET OBSERVER TO NUN

      CALL MISSING(YR,YRF,YRL,STA,RT,HRD,IFLAG,ALT,isuper)
      IF(IFLAG .EQ. 1) GO TO 50
      IF(RT .NE. RTNOW) GO TO 500
      IF(STA .NE. STANOW) GO TO 500
      CALL SETDATA(N,YR,OBSIN,HRD,OBS,DES,CNT,LINEAR,DST,DIST,NDIST,isuper)
      GO TO 50

  500 CONTINUE

C  NOW HERE IS THE ANALYSIS,  NOW CALL IN SUPERDECK: IT WILL ADD IN ZERO ROUTES.

      IF(alt.ne.9) CALL SUPER(RTNOW,STANOW,N,NOBS,DES,CNT,OBS,STRNOW,NOCO,YRF,YRL,isuper)

C  CHECK FOR ALL ZERO ROUTES

  543 continue
      CALL ALLZERO(STANOW,RTNOW,N,NOBS,CNT,IFLAG,LINEAR,NDIST, STRNOW,ALT)
      IF(IFLAG .EQ. 1) GO TO 600

C  CALL THE ANALYSIS. DONT LET THE ROUTES WITH N=2 GO IN TO ANALY

      if(((iflag.eq.3).and.(linear.eq.3)).or.(linear.eq.2)) call SETCOLMN(NOBS,N,NCOL,DES,OBS)
      if(iflag.eq.3) iflag=2
      IF(IFLAG .EQ. 2) GO TO 550
      if(linear.eq.2) go to 620
      CALL ANALY(NOBS,N,NCOL,DES,OBS,CNT,BMAT,COVA,MARGM,VARMAR, WTXPX)

C   CALL THE BACK-TRANSFORMATION SUBROUTINE FOR THE SLOPE

      MSEDF=N-NCOL
      IF(LINEAR.ne.1) CALL PAULTRAN(MSEDF,BMAT(2),COVA(2,2),BLUES)
  550 IF(IFLAG .EQ. 2) CALL SETTWO(N,NOBS,DES,BMAT(2),COVA(2,2), MSEDF,MARGM,VARMAR,CNT,WTXPX,OBS)
      IF(LINEAR.EQ. 1) BLUES=BMAT(2)
      IF((IFLAG.EQ.2).AND.(LINEAR.nE.1)) BLUES=EXP(BMAT(2))
      CALL GMNEED(MIDYR,N,DES,MARGM,VARMAR,CNT,IFLAG,MSEDF, CMAX,CMIN,SUM)  !   NOW CALL THE SUBROUTINE TO BACK TRANSFORM THE MARGINAL MEAN.

C  I HAVE LEFT THE DF=N-NCOL REGARDLESS OF WHICH MEAN IS USED!

      IF((LINEAR.ne.1).AND.(IFLAG.NE.2))  CALL PAULTRAN(MSEDF,MARGM,VARMAR,BACKM)
      IF(LINEAR .EQ. 1) BACKM=MARGM
      IF(IFLAG .EQ. 2) BACKM=EXP(MARGM)
      IF(LINEAR .ne. 1) BACKM=BACKM-0.5
      IF((BACKM.LE.0.0).and.(iflag.ne.2)) BACKM=0.001  !  ROUNDOFF ERROR COULD MAKE THE BACK-TRANSFORMED MMEAN < 0,  SO IF IT IS NEGATIVE, MAKE IT A SMALL POSITIVE VALUE.

      IF((BLUES.GT.0.0).OR.(BACKM.GT.0.0).OR.(WTXPX.GT.0.0)) NOSLOPES=1  !  IF SLOPE  EXISTS, SET NOSLOPES TO 1
      malt=1


  620 if((linear.eq. 2).or.(alt.eq.5)) CALL INDELOIS(N,NCOL,RTNOW,STANOW,STRNOW,DES,CNT,AOUIN,YRF,YRL,blues,backm,sum,alt) !   Here is the lowess subroutine
      if(blues.lt.-9990.0d0) go to 345
      MYR=1000
      DO II=1,N
         IF(DES(II,2).LT.MYR) MYR=int(DES(II,2))
      END DO

      MSEDF=N-NCOL
c    here is a version that prints out a variance      jrs 11 May 1994.   this is a variance based on the bradu-mundlac stuff

      wtm=(blues/exp(bmat(2)))*exp(2.0*bmat(2))*cova(2,2)*10000.
c  this doesn't work for routes with only 1 nonzero count or with 2-year trends.  do not print these

      ast=stanow*1000+rtnow
      bluesm=(blues-1.0)*100.0
      if(imnwt.eq. 2) call minwt(N,NCOL,DES,CNT,YRF,cmin)

      IFLAG=0  !   here is the call the the estimating equation approach 15 june 1994
      if(linear.eq.3) CALL calclink(stanow,rtnow,N,NCOL,DES,CNT,YRF,Blink,iflag,blues,blvar)
c  if iflag = 0, skip writert
      if(linear.eq.3) blues=blink
      if(linear.eq.3) call cutxpx(N,NCOL,DES,WTXPX,cnt)
      if(linear.eq.3) cova(2,2)=blvar
      IF((linear.eq.3).and.(IFLAG.EQ.0)) GO TO 345
      if(linear.eq.2) go to 345
      CALL WRITERT(RTNOW,STANOW,STRNOW,COVA,BLUES, VARMAR,BACKM,WTXPX,CMAX,CMIN,SUM,N,AOU,alt)
  345 continue

C REMEMBER TO RESET THE ROUTE

  600 continue

      RTNOW=RT
      STANOW=STA
      if(isuper.ne.1) STRNOW=STR
      N=0
      NOBS=1
 !     CALL SETDATA(N,NOBS,YR,OBSIN,HRD,OBS,DES,CNT,LINEAR,DST,DIST,NDIST,isuper)
      CALL SETDATA(N,YR,OBSIN,HRD,OBS,DES,CNT,LINEAR,DST,DIST,NDIST,isuper)
      GO TO 50

 1000 CONTINUE

C  NOW ANALYZE THE LAST GROUP.  NOW CALL IN SUPERDECK: IT WILL ADD IN ZERO ROUTES.

      IF(alt.ne.9) CALL SUPER(RTNOW,STANOW,N,NOBS,DES,CNT,OBS,STRNOW,NOCO,YRF,YRL,isuper)

C  CHECK FOR ALL ZERO ROUTES

      CALL ALLZERO(STANOW,RTNOW,N,NOBS,CNT,IFLAG,LINEAR,NDIST, STRNOW,ALT)
      IF(IFLAG .EQ. 1) RETURN

      if(((iflag.eq.3).and.(linear.eq.3)).or.(linear.eq.2)) call SETCOLMN(NOBS,N,NCOL,DES,OBS)
      IF(IFLAG .EQ. 3) iflag=2
      IF(IFLAG .EQ. 2) GO TO 750

C  CALL THE ANALYSIS

      if(linear.eq.2) go to 640
      CALL ANALY(NOBS,N,NCOL,DES,OBS,CNT,BMAT,COVA,MARGM,VARMAR, WTXPX)
      MSEDF=N-NCOL            !   CALL THE BACK-TRANSFORMATION SUBROUTINE FOR THE SLOPE
      IF(LINEAR.ne.1) CALL PAULTRAN(MSEDF,BMAT(2),COVA(2,2),BLUES)
  750 IF(IFLAG .EQ. 2) CALL SETTWO(N,NOBS,DES,BMAT(2),COVA(2,2), MSEDF,MARGM,VARMAR,CNT,WTXPX,OBS)
      IF(LINEAR .EQ. 1) BLUES=BMAT(2)
      IF((IFLAG.EQ.2).AND.(LINEAR.ne.1)) BLUES=EXP(BMAT(2))

C            NOW CALL THE SUBROUTINE TO BACK TRANSFORM THE MARGINAL MEAN.
      CALL GMNEED(MIDYR,N,DES,MARGM,VARMAR,CNT,IFLAG,MSEDF,CMAX,CMIN,SUM)
      IF((LINEAR.ne. 1).AND.(IFLAG.NE.2)) CALL PAULTRAN(MSEDF,MARGM,VARMAR,BACKM)
      IF(LINEAR .EQ. 1) BACKM=MARGM
      IF(IFLAG .EQ. 2) BACKM=EXP(MARGM)
      IF(LINEAR .ne. 1) BACKM=BACKM-0.5

C  ROUNDOFF ERROR COULD MAKE THE BACK-TRANSFORMED MMEAN < 0,  SO IF NEGATIVE, MAKE IT A SMALL POSITIVE  if 2 years, let it be 0
      IF((BACKM.LE.0.0).and.(iflag.ne.2)) BACKM=0.001 
      IF((BLUES.GT.0.0).OR.(BACKM.GT.0.0).OR.(WTXPX.GT.0.0)) NOSLOPES=1
      malt=1
  640 if((linear.eq. 2).or.(alt.eq.5)) CALL INDELOIS(N,NCOL,RTNOW,STANOW,STRNOW,DES,CNT,AOUIN,YRF,YRL,blues,backm,sum,alt)  !   Here is the lowess subroutine
      if(blues.lt.-9990.0d0) go to 346
      MYR=1000
      DO II=1,N
         IF(DES(II,2).LT.MYR) MYR=int(DES(II,2))
      END DO

      MSEDF=N-NCOL

c    here is a version that prints out a variance       jrs 11 May 1994.   this is a variance based on the bradu-mundlac stuff

      wtm=(blues/exp(bmat(2)))*exp(2.0*bmat(2))*cova(2,2)*10000.0
      ast=stanow*1000+rtnow
      bluesm=(blues-1.0)*100.0

      if(imnwt.eq. 2) call minwt(N,NCOL,DES,CNT,YRF,cmin)
      IFLAG=0                !   here is the call the the estimating equation approach 15 june 1994
      if(linear.eq.3) CALL calclink(stanow,rtnow,N,NCOL,DES,CNT,YRF,Blink,iflag,blues,blvar)
      if(linear.eq.3) blues=blink
      if(linear.eq.3) cova(2,2)=blvar
      if(linear.eq.3) call cutxpx(N,NCOL,DES,WTXPX,cnt)
c         if iflag = 0, skip writert
      if(linear.eq.2) go to 346
      IF((linear.eq.3).and.(IFLAG.EQ.0)) go to 346
      write(*,*) 'before writert in slopec2'
      CALL WRITERT(RTNOW,STANOW,STRNOW,COVA,ANG,BLUES, VARMAR,BACKM,WTXPX,CMAX,CMIN,SUM,N,AOUIN,alt)
  346 continue
      RETURN

 1100 MFLAG=1
      iend=0
      return
      END
