stateval <- function(rnum,alt,isuper,linear ) {

#  the control card sets all elements of the matrices to zero.
#  be sure to do this if you do not have this option!
#  this program takes a listing of areas (states & strata) of
#  interest from file 04, then reads in all relevant routes
#  from those areas with estimates of variances and calculates
#  bootstrapped estimates of the overall area slopes with weights
#  described by geissler.
#
#   input  unit 04= state, strata, and area file
#          unit 05= slope and variance file
#   output unit 06= bootstrap output
#
#    arrays: st(27) = character*4 array of states
#            sr(27,4) =  real array of strata (j,1),
#                         and areas (j,2).
#                         region= (j,3),
#                         nroutes=(j,4).
#            n(27) = integer array of number of routes in area m
#            ob(27,3,n)= real array of slopes (j,1,n), variances (j,2,n),
#                          and marginal means (j,3,n)
#                          and first yr (j,4,n), and last yr (j,5,n)
#                          and arithmetic average (j,6,n).
#
#    indices:    m= # of areas  (range= 1,27)
#                n(m)= n of routes in area m
#
#   i have stopped it from printing out everything but the estimates  and the ci's 3 june 1986
#   set up the seed for the random number generator
#

# real ob(280,6,150),sr(280,4),st(280)
# integer n(280,4), m, storstr,numin,alt,isuper,rnum
# character*3 stchr, statchr
# common /o/ ob

rnum=0  #    set up the aou number for printing out.
nflag=0 #    set up the counter for the records in the biglist

#rewind 8  !   more than 1 state occurs, so rewind unit 8 to be reread
m=1
numin=as.numeric(substr(a19[1],1,3))
statchr=substr(a19[1],4,6)
#read(19,'(i3,a3)',end=1020) numin, statchr  # read in the list of state-strata areas of interest from file04
n=matrix(0,numin,4)
for (m in 1:numin) {
   if (isuper == 1) { #read(19,25,end=1020) sr(m,3),stchr,st(m),sr(m,1),sr(m,2),sr(m,4)
      sr[m,3]=as.numeric(substr(a19[m+1],1,1))
      stchr=substr(a19[m+1],13,15)
      st[m]=as.numeric(substr(a19[m+1],16,17))
      sr[m,1]=as.numeric(substr(a19[m+1],18,19))
      sr[m,2]=as.numeric(substr(a19[m+1],20,26))
      sr[m,4]=as.numeric(substr(a19[m+1],28,31))
   }  #   25    format(f1.0,11x,a3,2f2.0,f7.0,1x,f4.0)
   if (isuper != 1) { # read(19,26,end=1020) sr(m,3),stchr,st(m),sr(m,1),sr(m,2)
      sr[m,3]=as.numeric(substr(a19[m+1],1,1))
      stchr=substr(a19[m+1],9,11)
      st[m]=as.numeric(substr(a19[m+1],12,14))
      sr[m,1]=as.numeric(substr(a19[m+1],15,17))
      sr[m,2]=as.numeric(substr(a19[m+1],18,23))     
   }   # 26    format(f1.0,7x,a3,2f3.0,f6.2)
   if(statchr == 'nos') sr[m,2]=1.
   n[m,1:4]=0
}

#  all areas have been read in, and the index for areas is reset,  so now read in the slopes, store them by area, and increment the area counts.

storstr=1  #     set up the index for state estimates storstr=1
xcall=readstsr(m,st,sr,n,alt,isuper,linear)
return(list(ob=xcall$ob, n=xcall$n, st=st, sr=sr))
}
