      SUBROUTINE STATEVAL(RNUM,ALT,isuper,linear )

C  THE CONTROL CARD SETS ALL ELEMENTS OF THE MATRICES TO ZERO.
C  BE SURE TO DO THIS IF YOU DO NOT HAVE THIS OPTION!
C  THIS PROGRAM TAKES A LISTING OF AREAS (STATES & STRATA) OF
C  INTEREST FROM FILE 04, THEN READS IN ALL RELEVANT ROUTES
C  FROM THOSE AREAS WITH ESTIMATES OF VARIANCES AND CALCULATES
C  BOOTSTRAPPED ESTIMATES OF THE OVERALL AREA SLOPES WITH WEIGHTS
C  DESCRIBED BY GEISSLER.
C
C   INPUT  UNIT 04= STATE, STRATA, AND AREA FILE
C          UNIT 05= SLOPE AND VARIANCE FILE
C   OUTPUT UNIT 06= BOOTSTRAP OUTPUT
C
C    ARRAYS: ST(27) = CHARACTER*4 ARRAY OF STATES
C            SR(27,4) =  REAL ARRAY OF STRATA (J,1),
C                         AND AREAS (J,2).
C                         REGION= (J,3),
C                         NROUTES=(J,4).
C            N(27) = INTEGER ARRAY OF NUMBER OF ROUTES IN AREA M
C            OB(27,3,N)= REAL ARRAY OF SLOPES (J,1,N), VARIANCES (J,2,N),
C                          AND MARGINAL MEANS (J,3,N)
C                          AND FIRST YR (J,4,N), AND LAST YR (J,5,N)
C                          AND ARITHMETIC AVERAGE (J,6,N).
C
C    INDICES:    M= # OF AREAS  (RANGE= 1,27)
C                N(M)= N OF ROUTES IN AREA M
C
C   I HAVE STOPPED IT FROM PRINTING OUT EVERYTHING BUT THE ESTIMATES  AND THE CI'S 3 JUNE 1986
C   SET UP THE SEED FOR THE RANDOM NUMBER GENERATOR
C

      REAL OB(280,6,150),SR(280,4),ST(280)
      INTEGER N(280,4), M, STORSTR,NUMIN,ALT,isuper,RNUM
      CHARACTER*3 STCHR, STATCHR
      COMMON /O/ OB

      RNUM=0  !    SET UP THE AOU NUMBER FOR PRINTING OUT.
      NFLAG=0 !    SET UP THE COUNTER FOR THE RECORDS IN THE BIGLIST

      REWIND 8  !   MORE THAN 1 STATE OCCURS, SO REWIND UNIT 8 TO BE REREAD
      M=1
      READ(19,'(i3,a3)',END=1020) NUMIN, STATCHR  !   READ IN THE LIST OF STATE-STRATA AREAS OF INTEREST FROM FILE04
      N(1,1)=0
      N(1,2)=0
      N(1,3)=0
      N(1,4)=0
      do while (m .le.numin)
         if(isuper.eq. 1) READ(19,25,END=1020) SR(M,3),STCHR,ST(M),SR(M,1),SR(M,2),SR(M,4)
   25    FORMAT(F1.0,11X,A3,2F2.0,F7.0,1X,F4.0)
         if(isuper.ne. 1) READ(19,26,END=1020) SR(M,3),STCHR,ST(M),SR(M,1),SR(M,2)
   26    FORMAT(F1.0,7X,A3,2F3.0,F6.2)
         if(STATCHR.eq.'NOS') sr(m,2)=1.
         N(M,1)=0
         N(M,2)=0
         N(M,3)=0
         N(M,4)=0
         M=M+1
      end do
      M=M-1

C  ALL AREAS HAVE BEEN READ IN, AND THE INDEX FOR AREAS IS RESET,  SO NOW READ IN THE SLOPES, STORE THEM BY AREA, AND INCREMENT THE AREA COUNTS.

      STORSTR=1  !     SET UP THE INDEX FOR STATE ESTIMATES STORSTR=1
      CALL READSTSR(M,ST,SR,N,ALT,isuper,linear)
 1020 RETURN
      END
