super <- function(rt,sta,n,nobs,des,cnt,obs,strnow,noco,yrf,yrl,isuper) {
    #  this is the subroutine to call in superdeck to get the routes with 0 birds seen
    if(isuper == 1) {
    #         this is set up to read sequentially through a file of state-route
    #         codes (the superdeck) and (at the same time) through a file of
    #         state-route observer codes.  it is assumed that the 2 input files
    #         are identical with regard to the state-route codes on each line.
    #         a line is read for each route in the count dataset.  if the state-
    #         route code on the superdeck line does not match the state-route
    #         code on the data line, the next line is read.  this will
    #         continue until the eof is reached, when an error message
    #         is printed and the file units are reset 
        yr[floor(des[,2])-1965]=1:n; stain=strnow=obshold=type=NULL
        stain=-999
        for (i20 in 1:length(a20)) {
            if (sta == stain && rt == rtin) {
                stain=as.numeric(substr(a20[i20],1,2)); rtin=as.numeric(substr(a20[i20],3,5))
                strnow=as.numeric(substr(a20[i20],6,7))
                #  read an obs from the observer deck (non-ksam)
                obshold=unlist(sapply(1:myrs,function(i)substr(a20[i20],8+(i-1)*6,12+(i-1)*6)))
                type=as.numeric(unlist(sapply(1:myrs,function(i)substr(a20[i20],13+(i-1)*6,13+(i-1)*6))))   
            }            
        }
        if (is.null(stain)) cat(' no observerdeck found, route=',rt,' state=',sta,'\n') 
        else {
            #     match up years in deck with routes observed and add on extras.
            #     -------------------------------------------------------------
            #     note that i must be equal to the max # years in the data set#
            #     for each year, 66-?, see if data are valid (from observerdeck)
            #     -------------------------------------------------------------
            m=0; nx=n
            for (i in 1:myrs) {   #  dump out ot range years
                iyr=1965+i         #   check to see if data are valid
                if(iyr >= yrf && iyr <= yrl && type[i] >= 1 && type[i] <= 3 && obshold[i] != '     ') {
                    if(yr[i] > 0) { m=m+1; obs[m]=obshold[i]; des[m,2]=des[yr[i],2]; cnt[m]=cnt[yr[i]] }
                    else { nx=nx+1; obs[nx]=obshold[i]; cnt[nx]=-0.6931471805599; des[nx,2]=i+1965; yr[i]=i }
                }
            }
            for (i in (n+1):nx) { m=m+1; obs[m]=obs[i]; des[m,2]=des[i,2]; cnt[m]=cnt[i] }
            n=m

            if(noco == 1) obs[1]='    '  #   if no observer covariable, set all observers to 1.
            nobs=1    #   now find the number of observers
            for (i in 2:n) { #  start with number 2, and see if it appears before. if not, add 1 to nobs
                if(noco == 1) obs[i]='     '
                else { 
                    iflag=sum(obs[i] == obs[1:(i-1)])
                    if(iflag==0) nobs=nobs+1
                }
            }
        }
           
    }
    return(list(obs=obs, des=des, cnt=cnt, type=type, yr=yr, strnow=strnow, nobs=nobs, n=n))
}
