      SUBROUTINE SUPER(RT,STA,N,NOBS,DES,CNT,OBS,STRNOW,NOCO,YRF,YRL,isuper)

C  THIS IS THE SUBROUTINE TO CALL IN SUPERDECK TO GET THE ROUTES WITH 0 BIRDS SEEN

      PARAMETER (MYRS=200,MCOLS=40)
      DOUBLE PRECISION DES(MYRS,MCOLS),CNT(MYRS)
      CHARACTER*5 OBS(MYRS),OBSHOLD(MYRS)
      REAL RT,STA,STRNOW,STAIN,RTIN
      INTEGER TYPE(MYRS),NOCO ,N,NOBS,YR(MYRS),isuper
      LOGICAL IFLAG

      if(isuper.eq.1) then

C         THIS IS SET UP TO READ SEQUENTIALLY THROUGH A FILE OF STATE-ROUTE
C         CODES (THE SUPERDECK) AND (AT THE SAME TIME) THROUGH A FILE OF
C         STATE-ROUTE OBSERVER CODES.  IT IS ASSUMED THAT THE 2 INPUT FILES
C         ARE IDENTICAL WITH REGARD TO THE STATE-ROUTE CODES ON EACH LINE.
C         A LINE IS READ FOR EACH ROUTE IN THE COUNT DATASET.  IF THE STATE-
C         ROUTE CODE ON THE SUPERDECK LINE DOES NOT MATCH THE STATE-ROUTE
C         CODE ON THE DATA LINE, THE NEXT LINE IS READ.  THIS WILL
C         CONTINUE UNTIL THE EOF IS REACHED, WHEN AN ERROR MESSAGE
C         IS PRINTED AND THE FILE UNITS ARE RESET
   
         YR=0
         DO I=1,N
           YR(INT(DES(I,2))-1965)=I
         END DO

         STAIN=-999
         DO WHILE (STA.NE.STAIN .OR. RT.NE.RTIN)
            READ(20,10,END=130)STAIN,RTIN,STRNOW,(OBSHOLD(I),TYPE(I),I=1,MYRS)  !  READ AN OBS FROM THE OBSERVER DECK (NON-KSAM)
   10       FORMAT(F2.0,F3.0,F2.0,50(A5,I1))                           !      NOW, IF THE KEY'S DON'T MATCH, READ IN THE NEXT VALUE
         END DO

C     MATCH UP YEARS IN DECK WITH ROUTES OBSERVED AND ADD ON EXTRAS.
C     -------------------------------------------------------------
C     NOTE THAT I MUST BE EQUAL TO THE MAX # YEARS IN THE DATA SET!
C     FOR EACH YEAR, 66-?, SEE IF DATA ARE VALID (FROM OBSERVERDECK)
C     -------------------------------------------------------------
         M=0
         NX=N
         DO I=1,MYRS   !  DUMP OUT OT RANGE YEARS
            IYR=1965+I         !   CHECK TO SEE IF DATA ARE VALID
            IF(IYR.GE.YRF .AND. IYR.LE.YRL .AND. TYPE(I).GE.1 .AND.TYPE(I).LE. 3 .AND. OBSHOLD(I).NE. '     ') THEN
               IF(YR(I).GT.0) THEN
                 M=M+1
                 OBS(M)=OBSHOLD(I)
                 DES(M,2)=DES(YR(I),2)
                 CNT(M)=CNT(YR(I))
               ELSE
                 NX=NX+1
                 OBS(NX)=OBSHOLD(I)
                 CNT(NX)=-0.6931471805599D0
                 DES(NX,2)=I+1965
                 YR(I)=I
               ENDIF
            END IF
         END DO
         DO I=N+1,NX
           M=M+1
           OBS(M)=OBS(I)
           DES(M,2)=DES(I,2)
           CNT(M)=CNT(I)
         END DO
         N=M
      end if

      IF(NOCO .EQ. 1) OBS(1)='    '  !   IF NO OBSERVER COVARIABLE, SET ALL OBSERVERS TO 1.
      NOBS=1    !   NOW FIND THE NUMBER OF OBSERVERS
      DO I=2,N  !  START WITH NUMBER 2, AND SEE IF IT APPEARS BEFORE. IF NOT, ADD 1 TO NOBS
        IF(NOCO .EQ. 1) THEN
           OBS(I)='     '
        ELSE
          IFLAG=.TRUE.
          DO J=1,I-1
            IF(OBS(I).EQ.OBS(J))IFLAG=.FALSE.
          END DO
          IF(IFLAG) NOBS=NOBS+1
        ENDIF
      END DO
      RETURN

  130 WRITE(*,135) RT,STA  !   IF YOU GET TO 130, NO ROUTE FOUND, SO PRINT WARNING, REWIND 9, AND EXIT.
  135 FORMAT(1X,'NO OBSERVERDECK FOUND, ROUTE=',F5.0,' STATE=', F7.0)

      REWIND 20 !   NOW RESET THE  OBSERVER DECK SO THAT THE NEXT ROUTE CAN BE ANALYZED
      RETURN
      END
