      FUNCTION TPROB(DF,T)  !  FUNCTION TO COMPUTE THE PROBABILITY OF A "T" VALUE
C                              WITH "IDF" DEGREES OF FREEDOM USING A STUDENTS-T DISTRIBUTION

      PI=3.141592653
      IDF=INT(DF)
      TPROB=1.0
      IF(IDF.LE.0) RETURN
      A=ATAN(T/SQRT(DF))
      TPROB=1-A/PI+.5
      IF(IDF.EQ.1) RETURN
      TPROB=1 - (SIN(A)/2.+.5)
      IF(IDF.EQ.2) RETURN
      IF(IDF.eq.3) THEN
        TPROB=1 - ((A+SIN(A)*COS(A))/PI+.5)
        RETURN
      ELSE
         SUM=0.
         PROD=1.
         COSA=COS(A)
         COSSQ=COSA*COSA
         IF(FLOAT(INT(DF/2))*2. .NE. DF) THEN
            DO I=1,IDF-4,2                            !  DF IS ODD
              PROD=PROD*FLOAT(I+1)/FLOAT(I+2)*COSSQ
              SUM=SUM+PROD*COSA
            END DO
            TPROB=1 - ((A+SIN(A)*(SUM+COSA))/PI+.5)
         ELSE
            DO I=1,IDF-3,2                            !  DF IS EVEN
              PROD=PROD*FLOAT(I)/FLOAT(I+1)*COSSQ
              SUM=SUM+PROD
            END DO
            TPROB=1 - ((SUM+1.)*SIN(A)/2.+.5)
         END IF
      END IF
      RETURN
      END
